﻿# -*- coding: utf-8 -*-

##############################################################################
#
# Copyright (c) 2007-2008 Naritas Ltda. (http://www.naritasltda.com) All Rights Reserved.
#
# $Id$
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License 
# Version 3 as published by the Free Software Foundation 
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

"""
Módulo para la gestión de logística de contenedores
"""
__author__ = "Naritas Ltda."
__date__ = "01/06/2007"

import time
import netsvc
from osv import fields, osv
import ir
from mx import DateTime
from datetime import date, timedelta

class oplog_do(osv.osv):
	def _aci_get(self, cr, uid, context={}):
		obj = self.pool.get('res.partner')
		cr.execute('select category_id from res_partner_category_rel where category_id=3')
		category_ids = [x[0] for x in cr.fetchall()]
		ids = obj.search(cr, uid, [('active', '=', 'true'), ('category_id', 'in', category_ids)])
		res = obj.read(cr, uid, ids, ['name','active'], context)
		return [(r['name'], r['name']) for r in res]

	def _naviera_get(self, cr, uid, context={}):
		obj = self.pool.get('res.partner')
		cr.execute('select category_id from res_partner_category_rel where category_id=4')
		category_ids = [x[0] for x in cr.fetchall()]
		ids = obj.search(cr, uid, [('active', '=', 'true'), ('category_id', 'in', category_ids)])
		res = obj.read(cr, uid, ids, ['name','active'], context)
		return [(r['name'], r['name']) for r in res]
		
	def _linea_get(self, cr, uid, context={}):
		obj = self.pool.get('res.partner')
		cr.execute('select category_id from res_partner_category_rel where category_id=5')
		category_ids = [x[0] for x in cr.fetchall()]
		ids = obj.search(cr, uid, [('active', '=', 'true'), ('category_id', 'in', category_ids)])
		res = obj.read(cr, uid, ids, ['name','active'], context)
		return [(r['name'], r['name']) for r in res]
		
	def _after15Days(self, cr, uid, ids, name, args, context={}):
		return self.getDeltaDate(cr, uid, ids, name, -15, context)
		
	def _after5Days(self, cr, uid, ids, name, args, context={}):
		return self.getDeltaDate(cr, uid, ids, name, -5, context)

	def getDeltaDate(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			do = self.browse(cr, uid, id)
			if do.fecha_de_arrivo:
				temp = time.strptime(do.fecha_de_arrivo, '%Y-%m-%d %H:%M:%S')
				theDate = date(temp[0], temp[1], temp[2]) + timedelta(days=args)
				res[id] = str(theDate)
			else:
				res[id] = None
		#print res
		return res

	#def create(self, cr, uid, vals, context={}):
		# Conditions to meet for records creation
		# Solo para radicacion y vaciado.
		#do = self.pool.get('oplog.do')
	#	if vals['regimen'] in ['RADICACION','Radicacion','VACIADO','Vaciado']:
			#vals['state'] = 'cerrado'
			#return super(oplog_do, self).create(cr, uid, vals)
	#		naviero = self.pool.get('oplog.naviero')
	#		naviero_val = {'naviero_id': id}
	#		naviero.create(cr, uid, naviero_val)
	#
	#		anticipo = self.pool.get('oplog.anticipo')
	#		anticipo_val = {'fondos_id': id}
	#		anticipo.create(cr, uid, anticipo_val)
	#
	#		radpuerto = self.pool.get('oplog.radpuerto')
	#		radpuerto_val = {'radpuerto_id': id}
	#		radpuerto.create(cr, uid, radpuerto_val)		
	#	return True

	def SpecialClose(self, cr, uid, ids, context={}):
		#print "SpecialClose"
		
		for o in self.browse(cr, uid, ids):
			if o.regimen not in ['LIBERACION','Liberacion','COLOADING','Coloading']:
				raise osv.except_osv('Por favor chequee el regimen', "Regimen debe ser 'LIBERACION' o 'COLOADING'")
			if o.regimen in ['LIBERACION','Liberacion']:
				do_check = False
				if not o.codigo_blmaster:
					raise osv.except_osv('No hay BLM', "No se puede encontrar BLMs, por favor revise su registro en TinyERP.")
				has_blh = False
				has_container = False
				for blm in o.codigo_blmaster:
					blhs = blm.codigo_blhijo
					if blhs:
						has_blh = True
						for blh in blhs:
							if not blh.liberado:
								raise osv.except_osv('Liberaciones', "Las Liberaciones de HBL(s) de este DO no se han realizado.")
					conts = blm._getContainerNumber(cr, uid, [blm.id], '', None)
					if conts and blm.id in conts:
						has_container = conts[blm.id] > 0
				if not has_blh:
					raise osv.except_osv('No hay HBL', "No se puede encontrar HBLs, por favor revise o realice su registro en el DO.")
				if not has_container:
					raise osv.except_osv('No hay contenedores', "No se puede encontrar contenedores, por favor revise o realice su registro en el MBL.")			
			self.write(cr, uid, ids, {'state':'cerrado'})
		return True
		
	def apertura_confirm(self, cr, uid, ids, context={}):
		#print "apertura_confirm"
		#print ids
		# Check apertura
		port_dict = {}
		today = date.strftime(date.today(), '%Y-%m-%d %H:%M:%S')
		for o in self.browse(cr, uid, ids):
			if o.regimen in ['LIBERACION','Liberacion','COLOADING','Coloading']:
				raise osv.except_osv('No necesita confirmación', "Usted debe presionar el botón 'Cierre Coloading &amp; Liberación' para cerrar.")
			do_check = False
			port_dict[o.id] = o.puerto_llegada
			if not o.codigo_blmaster:
				raise osv.except_osv('No hay BLM', "No se puede encontrar BLMs, por favor revise su registro en TinyERP.")
			has_blh = False
			has_container = False
			for blm in o.codigo_blmaster:
				blhs = blm.codigo_blhijo
				if blhs:
					has_blh = True
				#conts = blm.contenedor_id
				conts = blm._getContainerNumber(cr, uid, [blm.id], '', None)
				#print 'Container number:'
				#print conts
				if conts and blm.id in conts:
					has_container = conts[blm.id] > 0
			if not has_blh:
				raise osv.except_osv('No hay HBL', "No se puede encontrar HBLs, por favor revise o realice su registro en el DO.")
			if not has_container:
				raise osv.except_osv('No hay contenedores', "No se puede encontrar contenedores, por favor revise o realice su registro en el MBL.")
		# Check other condition
		for id in ids:
			o = self.browse(cr, uid, id)
			if not o.val_nav:
				# Check naviero
				naviero = self.pool.get("oplog.naviero")
				naviero_ids = naviero.search(cr, uid, [('naviero_id', '=', id)])
				#print naviero_ids
				naviero_obj = None
				if naviero_ids:
					naviero_obj = naviero.browse(cr, uid, naviero_ids[0])
				#print naviero_obj
				if not (naviero_obj and naviero_obj.fecha_nav):
					raise osv.except_osv('Carta al naviero', "La carta al naviero no se ha relizado o notificado.")
			# Check anticipo
			#anticipo = self.pool.get("oplog.anticipo")
			#anticipo_ids = anticipo.search(cr, uid, [('fondos_id', '=', id)])
			#print anticipo_ids
			#anticipo_obj = None
			#if anticipo_ids:
			#	anticipo_obj = anticipo.browse(cr, uid, anticipo_ids[0])
			#print anticipo_obj
			#if not (anticipo_obj and anticipo_obj.envio_fondos):
			#	raise osv.except_osv('Anticipo($)', "La recepción de anticipos no se ha realizado o notificado.")
			# Check oplog.radpuerto
			#radpuerto = self.pool.get("oplog.radpuerto")
			#radpuerto_ids = radpuerto.search(cr, uid, [('radpuerto_id', '=', id)])
			#print radpuerto_ids
			#radpuerto_obj = None
			#if radpuerto_ids:
			#	radpuerto_obj = radpuerto.browse(cr, uid, radpuerto_ids[0])
			#print radpuerto_obj
			#if not (radpuerto_obj and radpuerto_obj.rad_pto):
			#	raise osv.except_osv('Radicación en puerto', "La radicación en puerto no se ha relizado o notificado.")
			#if port_dict[id] != 'S.P.R.C.' and not (radpuerto_obj and radpuerto_obj.fact_pago):
			#	raise osv.except_osv('Radicación en puerto', "La radicación en puerto no se ha relizado o notificado.")
			
			# Create dian
			dian = self.pool.get('oplog.dian')
			dian_ids = dian.search(cr, uid, [('do_ids', '=', id)])
			if not dian_ids:
				dian_val = {'name': ' ', 
							'do_ids': id,
							'fecha_dian': today}
							#,
							#'hora_fin': today}
				dian.create(cr, uid, dian_val)

			# Create vaciado or radicacion
			if o.regimen in ['VACIADO','Vaciado']:
				vaciado = self.pool.get('oplog.vaciado')
				vaciado_ids = vaciado.search(cr, uid, [('do_vac_id', '=', id)])
				if not vaciado_ids:
					vaciado_val = {'do_vac_id': id, 'fecha_vaciado': today}
					vaciado.create(cr, uid, vaciado_val)
			elif o.regimen in ['RADICACION','Radicacion']:
				radicado = self.pool.get('oplog.radicado')
				radicado_ids = radicado.search(cr, uid, [('do_rad_id', '=', id)])
				if not radicado_ids:
					radicado_val = {'do_rad_id': id, 'fecha_radicado': today}
					radicado.create(cr, uid, radicado_val)
			# Write status
			self.write(cr, uid, ids, {'state':'tramite_dian'})
		return True

	def dian_confirm(self, cr, uid, ids, context={}):
		#print "dian_confirm"
		#print ids
		for id in ids:
			dian = self.pool.get("oplog.dian")
			dian_ids = dian.search(cr, uid, [('do_ids', '=', id)])
			#print dian_ids
			dian_obj = None
			if dian_ids:
				dian_obj = dian.browse(cr, uid, dian_ids[0])
			#print dian_obj
			if not (dian_obj and dian_obj.name):
				raise osv.except_osv('SYGA', "No existe No. del Manifiesto SYGA.")
			if not dian_obj.asocio_dian:
				raise osv.except_osv('PAQUETE CONSOLIDADOR', "No existe No. Paquete Consolidador.")
			if not dian_obj.hora_dian:
				raise osv.except_osv('Radicación Fisica DIAN', "La Radicación Fisica DIAN no se ha realizado o notificado.")
			do = self.browse(cr, uid, id)
			if do.regimen in ('VACIADO','Vaciado'):
				# Check oplog.vaciado
				vaciado = self.pool.get("oplog.vaciado")
				vaciado_ids = vaciado.search(cr, uid, [('do_vac_id', '=', id)])
				#print vaciado_ids
				vaciado_obj = None
				if vaciado_ids:
					vaciado_obj = vaciado.browse(cr, uid, vaciado_ids[0])
				#print vaciado_obj
				if not vaciado_obj:
					raise osv.except_osv('VACIADO', "No se ha iniciado con el vaciado de contenedor.")
				if not vaciado_obj.fecha_vobo:
					raise osv.except_osv('VACIADO', "Los Vistos Buenos no se han verificado o notificado.")
				if not vaciado_obj.fecha_lib_mbl:
					raise osv.except_osv('VACIADO', "La Liberación del MBL no se ha realizado o notificado.")
				if not vaciado_obj.fecha_pys:
					raise osv.except_osv('VACIADO', "El Paz y Salvo no se ha realizado o notificado.")
				if not vaciado_obj.fecha_fact_pto:
					raise osv.except_osv('VACIADO', "La presentación de Factura en puerto no se ha realizado o notificado.")
				if not vaciado_obj.date_vac_cnt:
					raise osv.except_osv('VACIADO', "El Vaciado de contenedor no se ha realizado o notificado.")
				if not vaciado_obj.date_pln_cnt:
					raise osv.except_osv('VACIADO', "La Planilla de entrega de Mercancias no se ha realizado o notificado.")
				#if not vaciado_obj.pln_trp:
				#	raise osv.except_osv('Vaciado', "La entrega de Planilla al transportador no se ha realizado o notificado.")
			if not dian_obj.hora_fin:
				raise osv.except_osv('Finalizacion Descargue DIAN', "La Finalizacion Descargue DIAN no se ha realizado o notificado.")				
			
			print "Create facturacion"
			#Create facturacion
			hora_fin = dian_obj.hora_fin
			if hora_fin:
				temp = time.strptime(hora_fin, '%Y-%m-%d %H:%M:%S')
				theDate = date(temp[0], temp[1], temp[2]) + timedelta(days=5)
				facturacion_val = {
					'name':dian_obj.name, 
					'fecha_finalizacion':hora_fin, 
					'fecha_vencimiento': "%s %s" % (str(theDate), time.strftime("%H:%M:%S", temp)),
					'facturacion_id':id,
					}
				facturacion = self.pool.get('oplog.facturacion')
				facturacion_ids = facturacion.search(cr, uid, [('facturacion_id', '=', id)])
				if not facturacion_ids:
					facturacion.create(cr, uid, facturacion_val)
			else:
				raise osv.except_osv('Finalizacion Descargue DIAN', "Creación de la facturación falló.")
			self.write(cr, uid, ids, {'state':'contabilidad'})
		return True

	def invoice_confirm(self, cr, uid, ids, context={}):
		#print "invoice_confirm"
		for id in ids:
			facturacion = self.pool.get("oplog.facturacion")
			facturacion_ids = facturacion.search(cr, uid, [('facturacion_id', '=', id)])
			print facturacion_ids
			facturacion_obj = None
			if facturacion_ids:
				facturacion_obj = facturacion.browse(cr, uid, facturacion_ids[0])
			print facturacion_obj
			if not (facturacion_obj and facturacion_obj.fecha_facturacion):
				raise osv.except_osv('Facturacion', "La facturación no se ha realizado o notificado.")
		self.write(cr, uid, [id], {'state':'cerrado'})
		return True

	def rollback(self, cr, uid, ids, context={}):
		# print context
		# self.write(cr, uid, ids, {'state': 'apertura'})

		wf_service = netsvc.LocalService('workflow')
		for do_obj in self.browse(cr, uid, ids):
			if do_obj.state == 'tramite_dian':
				self.write(cr, uid, [do_obj.id], {'state':'apertura'})
			elif do_obj.state == 'contabilidad':
				self.write(cr, uid, [do_obj.id], {'state':'tramite_dian'})
			elif do_obj.state == 'cerrado':
				if do_obj.regimen in ['LIBERACION','Liberacion','COLOADING','Coloading']:
					self.write(cr, uid, [do_obj.id], {'state':'apertura'})
				else:
					self.write(cr, uid, [do_obj.id], {'state':'contabilidad'})
			else:
				return False
			wf_service.trg_create(uid, self._name, do_obj.id, cr)
		return True

	def cancel_state(self, cr, uid, ids, context={}):
		for id in ids:
			self.write(cr, uid, ids, {'state':'cancel'})
		return True
		# #print 'cancel'
		# for do_obj in self.browse(cr, uid, ids):
			# if do_obj.state == 'cerrado':
				# #print do_obj.regimen
				# if do_obj.regimen in ['LIBERACION','Liberacion','COLOADING','Coloading']:
					# self.write(cr, uid, [do_obj.id], {'state':'cancel'})
				# else:
					# self.write(cr, uid, [do_obj.id], {'state':'cancel'})
			# elif do_obj.state == 'contabilidad':
				# self.write(cr, uid, [do_obj.id], {'state':'cancel'})
			# elif do_obj.state == 'tramite_dian':
				# self.write(cr, uid, [do_obj.id], {'state':'cancel'})
		# return True

	def _getFechaNaviera(self, cr, uid, ids, name, args, context={}):
			res = {}
			naviera = self.pool.get("oplog.naviero")
			for id in ids:
				do_obj = self.browse(cr, uid, id)
				#if do_obj.val_nav and do_obj.puerto_llegada != 'S.P.R.C':
				if do_obj.val_nav:
					res[id] = 'NO REQUIERE'
					continue
				res[id] = None
				naviera_ids = naviera.search(cr, uid, [('naviero_id', '=', id)])
				naviera_obj = None
				if naviera_ids:
					naviera_obj = naviera.browse(cr, uid, naviera_ids[0])
				if naviera_obj:
					res[id] = naviera_obj.fecha_nav
			return res
	def _getRcvNaviera(self, cr, uid, ids, name, args, context={}):
			res = {}
			naviera = self.pool.get("oplog.naviero")
			for id in ids:
				do_obj = self.browse(cr, uid, id)
				#if do_obj.val_nav and do_obj.puerto_llegada != 'S.P.R.C':
				if do_obj.val_nav:
					res[id] = 'NO REQUIERE'
					continue
				res[id] = None
				naviera_ids = naviera.search(cr, uid, [('naviero_id', '=', id)])
				naviera_obj = None
				if naviera_ids:
					naviera_obj = naviera.browse(cr, uid, naviera_ids[0])
				if naviera_obj:
					res[id] = naviera_obj.fecha_rcv
			return res
	def _getFechaRadpto(self, cr, uid, ids, name, args, context={}):
			res = {}
			radpuerto = self.pool.get("oplog.radpuerto")
			for id in ids:
				res[id] = None
				radpuerto_ids = radpuerto.search(cr, uid, [('radpuerto_id', '=', id)])
				radpuerto_obj = None
				if radpuerto_ids:
					radpuerto_obj = radpuerto.browse(cr, uid, radpuerto_ids[0])
				if radpuerto_obj:
					res[id] = radpuerto_obj.fecha_radicado
			return res
	def _getFactura(self, cr, uid, ids, name, args, context={}):
			res = {}
			radpuerto = self.pool.get("oplog.radpuerto")
			for id in ids:
				do_obj = self.browse(cr, uid, id)
				#if do_obj.val_nav and do_obj.puerto_llegada != 'S.P.R.C':
				if do_obj.puerto_llegada != 'S.P.R.C.':
					res[id] = 'NO REQUIERE'
					continue
				res[id] = None
				radpuerto_ids = radpuerto.search(cr, uid, [('radpuerto_id', '=', id)])
				radpuerto_obj = None
				if radpuerto_ids:
					radpuerto_obj = radpuerto.browse(cr, uid, radpuerto_ids[0])
				if radpuerto_obj:
					res[id] = radpuerto_obj.factura
			return res
	def _getFechaPaqCon(self, cr, uid, ids, name, args, context={}):
			res = {}
			dian = self.pool.get("oplog.dian")
			for id in ids:
				res[id] = None
				dian_ids = dian.search(cr, uid, [('do_ids', '=', id)])
				dian_obj = None
				if dian_ids:
					dian_obj = dian.browse(cr, uid, dian_ids[0])
				if dian_obj:
					res[id] = dian_obj.hora_asocio
			return res
	def _getManifiesto(self, cr, uid, ids, name, args, context={}):
			res = {}
			dian = self.pool.get("oplog.dian")
			for id in ids:
				res[id] = None
				dian_ids = dian.search(cr, uid, [('do_ids', '=', id)])
				dian_obj = None
				if dian_ids:
					dian_obj = dian.browse(cr, uid, dian_ids[0])
				if dian_obj:
					res[id] = dian_obj.name
			return res
	def _getFechaAsocio(self, cr, uid, ids, name, args, context={}):
			res = {}
			dian = self.pool.get("oplog.dian")
			for id in ids:
				res[id] = None
				dian_ids = dian.search(cr, uid, [('do_ids', '=', id)])
				dian_obj = None
				if dian_ids:
					dian_obj = dian.browse(cr, uid, dian_ids[0])
				if dian_obj:
					res[id] = dian_obj.hora_electronico
			return res
	def _getFechaFisico(self, cr, uid, ids, name, args, context={}):
			res = {}
			dian = self.pool.get("oplog.dian")
			for id in ids:
				res[id] = None
				dian_ids = dian.search(cr, uid, [('do_ids', '=', id)])
				dian_obj = None
				if dian_ids:
					dian_obj = dian.browse(cr, uid, dian_ids[0])
				if dian_obj:
					res[id] = dian_obj.hora_dian
			return res
	def _getFechaFin(self, cr, uid, ids, name, args, context={}):
			res = {}
			dian = self.pool.get("oplog.dian")
			for id in ids:
				res[id] = None
				dian_ids = dian.search(cr, uid, [('do_ids', '=', id)])
				dian_obj = None
				if dian_ids:
					dian_obj = dian.browse(cr, uid, dian_ids[0])
				if dian_obj:
					res[id] = dian_obj.hora_fin
			return res
#	def _getFechaRadFisica(self, cr, uid, ids, name, args, context={}):
#			res = {}
#			dian = self.pool.get("oplog.dian")
#			for id in ids:
#				res[id] = None
#				dian_ids = dian.search(cr, uid, [('do_ids', '=', id)])
#				dian_obj = None
#				if dian_ids:
#					dian_obj = dian.browse(cr, uid, dian_ids[0])
#				if dian_obj:
#					res[id] = dian_obj.hora_fin
#			return res
#	def _getHBL(self, cr, uid, ids, name, args, context={}):
#			res = {}
#			blh = self.pool.get("oplog.blhijo")
#			for id in ids:
#				res[id] = None
#				blh_ids = blh.search(cr, uid, [('blmaster_id.do_id', '=', id)])
#				blh_obj = None
#				if blh_ids:
#					blh_obj = blh.browse(cr, uid, blh_ids[0])
#				if blh_obj:
#					res[id] = blh_obj.name
#			return res

	def _getBlhNumber(self, cr, uid, ids, name, args, context={}):
			res = {}
			blm = self.pool.get("oplog.blmaster")
			for id in ids:
				res[id] = 0
				blm_ids = blm.search(cr, uid, [('do_id', '=', id)])
				blhNums = blm._getBlhNumber(cr, uid, blm_ids, name, args)
				if blhNums:
					for blh_cnt in blhNums.values():
						res[id] += blh_cnt
			return res
			
	def _getBlmNumber(self, cr, uid, ids, name, args, context={}):
			res = {}
			blm = self.pool.get("oplog.blmaster")
			for id in ids:
				res[id] = 0
				blm_ids = blm.search(cr, uid, [('do_id', '=', id)])
				res[id] = len(blm_ids)
			return res

	def _getContainerNumber(self, cr, uid, ids, name, args, context={}):
			res = {}
			blm = self.pool.get("oplog.blmaster")
			for id in ids:
				res[id] = 0
				blm_ids = blm.search(cr, uid, [('do_id', '=', id)])
				contNums = blm._getContainerNumber(cr, uid, blm_ids, name, args)
				if contNums:
					for cont_cnt in contNums.values():
						res[id] += cont_cnt
			return res
			
	def _getCreateUser(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			cr.execute('select u.name from oplog_do d left join res_users u on COALESCE(d.write_uid, d.create_uid) = u.id where d.id=%d', (id,))
			uname = cr.fetchone()
			if uname and len(uname) > 0:
				res[id] = uname[0]
			#res[id] = 'admin'
		#print res
		return res
	def _getAciDianCode(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			do_obj = self.browse(cr, uid, id)
			#print do_obj.aci
			cr.execute("select aci_dian_code from res_partner where name=%s", (do_obj.aci,))
			uname = cr.fetchone()
			if uname and len(uname) > 0:
				res[id] = uname[0]
		return res
	def _getBlhCsg(self, cr, uid, ids, name, args, context={}):
		res = {}
		# for do_obj in self.browse(cr, uid, ids):
			# res[do_obj.id] = []
			# for blm_obj in do_obj.codigo_blmaster:
				# for blh_obj in blm_obj.codigo_blhijo:
					# res[do_obj.id].append(blh_obj.consig_blh)
		for id in ids:
			res[id] = ''
		return res
	def _getBlh(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			res[id] = ''
		return res
	def _getContenedor(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			res[id] = ''
		return res
	def _searchByBlhCsg(self, cr, uid, obj, name, args, context={}):
		if not len(args):
			return []
		res = []
		# print obj, name, args, context
		blhijo = self.pool.get("oplog.blhijo")
		for f, o, v in args:
			blh_ids = blhijo.search(cr, uid, [('consig_blh', o, v)])
			do_ids = []
			for blh_id in blh_ids:
				blhijo_obj = blhijo.browse(cr, uid, blh_id)
				if blhijo_obj and blhijo_obj.blmaster_id and blhijo_obj.blmaster_id.do_id:
					do_ids.append(blhijo_obj.blmaster_id.do_id.id)
			if len(do_ids):
				res.append(('id','in',do_ids))
		if not len(res):
			return [('id', '=', 0)]
		# print res
		return res
	def _searchByBlh(self, cr, uid, obj, name, args, context={}):
		if not len(args):
			return []
		res = []
		# print obj, name, args, context
		blhijo = self.pool.get("oplog.blhijo")
		for f, o, v in args:
			blh_ids = blhijo.search(cr, uid, [('name', o, v)])
			do_ids = []
			for blh_id in blh_ids:
				blhijo_obj = blhijo.browse(cr, uid, blh_id)
				if blhijo_obj and blhijo_obj.blmaster_id and blhijo_obj.blmaster_id.do_id:
					do_ids.append(blhijo_obj.blmaster_id.do_id.id)
			if len(do_ids):
				res.append(('id','in',do_ids))
		if not len(res):
			return [('id', '=', 0)]
		# print res
		return res
	def _searchByContenedor(self, cr, uid, obj, name, args, context={}):
		if not len(args):
			return []
		res = []
		contenedor = self.pool.get("oplog.contenedor")
		blhijo = self.pool.get("oplog.blhijo")
		for f, o, v in args:
			contenedor_ids = contenedor.search(cr, uid, [('name', o, v)])
			# print contenedor_ids
			blh_ids = []
			do_ids = []
			for contenedor_obj in contenedor.browse(cr, uid, contenedor_ids):
				blh_ids.append(contenedor_obj.blh_id.id)
			# print blh_ids
			for blh_id in blh_ids:
				blhijo_obj = blhijo.browse(cr, uid, blh_id)
				if blhijo_obj and blhijo_obj.blmaster_id and blhijo_obj.blmaster_id.do_id:
					do_ids.append(blhijo_obj.blmaster_id.do_id.id)
			# print do_ids
			if len(do_ids):
				res.append(('id','in',do_ids))

		if not len(res):
			return [('id', '=', 0)]
		# print res
		return res
		
	_name = 'oplog.do'
	_log_access = True
	_columns = {
		# Data fields
		'name': fields.char('DO#', size=64, required=True, states={'apertura':[('readonly',False)],'tramite_dian':[('readonly',True)],'contabilidad':[('readonly',True)],'cerrado':[('readonly',True)],'cancel':[('readonly',True)]}),
		'sucursal': fields.selection([('CT','Cartagena'),('BQ','Barranquilla'),('BV','Buenaventura')],'Sucursal', required=True, size=4),
		'fecha_apertura_do' : fields.datetime('Fecha DO', required=True, readonly=True),
		'fecha_de_arrivo': fields.datetime('ETA'),
		'regimen': fields.selection([('LIBERACION','Liberacion'),('COLOADING','Coloading'),('RADICACION','Radicacion'),('VACIADO','Vaciado')],'Modalidad', required=True, size=32),
		'referencia': fields.char('Referencia', size=20),
		'naviera' : fields.selection(_naviera_get,'Naviera', required=True, size=45),
		'linea' : fields.selection(_linea_get,'Línea', required=True, size=45),
		'motonave': fields.char('Motonave', size=20, required=True),
		'viaje': fields.char('Viaje', size=20),
		'aci': fields.selection(_aci_get,'ACI', required=True, size=45),
		'puerto_llegada': fields.selection([('S.P.R.C.','S.P.R.C.'),('MUELLES EL BOSQUE','Muelles El Bosque'),('CONTECAR','CONTECAR')], 'Puerto de arribo', size=32, required=True),
		'puerto_embarque': fields.char('Puerto de embarque', size=32),
		'pais_embarque': fields.many2one('res.country', 'País embarque'),
		'r_aduanero': fields.char('R.Aduanero', size=64),
		'fecha_raduanero': fields.datetime('Fecha de r.aduanero'),
		'r_capitania': fields.char('R.Capitania',	size=64),
		'f_capitania': fields.datetime('Fecha de r.capitania'),
		'bandera': fields.many2one('res.country', 'Bandera'),
		'contacto':	fields.char('Contacto',	size=64),
		'anticipos': fields.boolean('Requiere anticipos'),
		'val_nav': fields.boolean('No requiere carta al naviero', help="Validación hecha por el naviero."),
		# Function fields
		#'blh_do': fields.function(_getHBL, method=True, string='HBL(s)', type='char', readonly=True),
		#'radfsc_dian': fields.function(_getFechaRadFisica, method=True, string='RAD.FISICA', type='char', readonly=True),
		'asocio_dian': fields.function(_getFechaAsocio, method=True, string='ASOCIO', type='char', readonly=True),
		'paqcon_dian': fields.function(_getFechaPaqCon, method=True, string='PAQ.CONS.', type='char', readonly=True),
		'manifiesto_dian': fields.function(_getManifiesto, method=True, string='MANIFIESTO', type='char', readonly=True),
		'fisico_dian': fields.function(_getFechaFisico, method=True, string='RAD.FISICA', type='char', readonly=True),
		'fin_dian': fields.function(_getFechaFin, method=True, string='FIN DIAN', type='char', readonly=True),
		'factura_radpuerto': fields.function(_getFactura, method=True, string='FACTURA', type='char', readonly=True),
		'fecha_radpuerto': fields.function(_getFechaRadpto, method=True, string='RAD.PTO', type='char', readonly=True),
		'fecha_naviera': fields.function(_getFechaNaviera, method=True, string='ENV.CARTA', type='char', readonly=True),
		'rcv_naviera': fields.function(_getRcvNaviera, method=True, string='RCB.CARTA', type='char', readonly=True),
		'fecha_de_arrivo_15': fields.function(_after15Days, method=True, type='date', string='Fecha 15'),
		'fecha_de_arrivo_5': fields.function(_after5Days, method=True, type='date', string='Fecha 5'),
		'blh_counter': fields.function(_getBlhNumber, method=True, type='integer', string='No. BLH'),
		'cont_counter': fields.function(_getContainerNumber, method=True, type='integer', string='No. Contenedores'),
		# Relational fields
		'pendientes_id': fields.one2many('oplog.pendiente', 'pendiente_id', 'Pendientes', size=32,required=True, select=True),
		'carta_id': fields.one2many('oplog.naviero', 'naviero_id', 'Carta naviero', size=32, required=True, select=True),
		'anticipo_id': fields.one2many('oplog.anticipo', 'fondos_id', 'Anticipo(s)', size=32,required=True, select=True),
		'radportdo_id': fields.one2many('oplog.radpuerto', 'radpuerto_id', 'Radicación en puerto', size=32, required=True, select=True),
		'codigo_blmaster': fields.one2many('oplog.blmaster', 'do_id', 'B/L Master(s)', required=True, select=True),
		'contenedor_id': fields.one2many('oplog.contenedor', 'contenedor_do_id', 'Contenedor', required=True, select=True),
		'hbl_id': fields.one2many('oplog.blhijo', 'blh_do_id', 'HBL', required=True, select=True),
		'do_dian_id': fields.one2many('oplog.dian', 'do_ids', 'Radicación en DIAN', required=True, select=True),
		'do_vaciado_id': fields.one2many('oplog.vaciado', 'do_vac_id', 'Vaciado', required=True, select=True),
		'do_facturacion_id': fields.one2many('oplog.facturacion', 'facturacion_id', 'Facturacion', required=True, select=True),
		# Process state and users
		'state': fields.selection([('apertura','Apertura'),('tramite_dian','Tramite DIAN'),('contabilidad','Facturación'),('cerrado','Cerrado'),('cancel','Cancelado')], 'Estado', required=True, select=True, readonly=True),
		'replicado': fields.boolean('Replicado'),
		#'user_id':fields.many2one('res.users','Abrió DO', size=20, readonly=True, select=True),
		'user_id': fields.function(_getCreateUser, method=True, type='char', string='Abrió DO'),
		'aci_dian_code': fields.function(_getAciDianCode, method=True, type='char', string='ACIDIANCODE'),
		'blh_csg': fields.function(_getBlhCsg, method=True, string='Consignatario', type='char', size=128, readonly=True, fnct_search=_searchByBlhCsg),
		'blh_name': fields.function(_getBlh, method=True, string='BLH', type='char', size=32, readonly=True, fnct_search=_searchByBlh),
		'contenedor_name': fields.function(_getContenedor, method=True, string='Contenedor', type='char', size=32, readonly=True, fnct_search=_searchByContenedor),
				}
	_order='fecha_de_arrivo'
	_defaults = {
		'fecha_apertura_do': lambda *a: time.strftime('%Y-%m-%d %H:%M:%S'),
		'sucursal': lambda *a: 'CT',
		'regimen': lambda *a: 'RADICACION',
		'puerto_llegada': lambda *a: 'S.P.R.C.',
		'state': lambda *a: 'apertura',
		'replicado': lambda *a: 0,
		#'user_id': lambda obj, cr, uid, context: uid,
		#'name': lambda obj, cr, uid, context: obj.pool.get('ir.sequence').get(cr, uid, 'oplog.do'),
				}

	def create(self, cr, uid, vals, context={}):
		# Conditions to meet for records creation
		# Solo para radicacion y vaciado.
		do_id = super(oplog_do, self).create(cr, uid, vals)
		today = date.strftime(date.today(), '%Y-%m-%d %H:%M:%S')
		#print do_id
		# Create oplog.nvaiero
		naviero = self.pool.get('oplog.naviero')
		naviero_ids = naviero.search(cr, uid, [('naviero_id', '=', do_id)])
		if not naviero_ids:
			naviero_val = {'name': vals['name'], 'naviero_id': do_id, 'fecha_naviero': today}
			naviero.create(cr, uid, naviero_val)
		# Create oplog.anticipo
		anticipo = self.pool.get('oplog.anticipo')
		anticipo_ids = anticipo.search(cr, uid, [('fondos_id', '=', do_id)])
		if not anticipo_ids:
			anticipo_val = {'name': vals['name'], 'fondos_id': do_id, 'fecha_anticipo': today}
			anticipo.create(cr, uid, anticipo_val)
		# Create oplog.radpuerto
		radpuerto = self.pool.get('oplog.radpuerto')
		radpuerto_ids = radpuerto.search(cr, uid, [('radpuerto_id', '=', do_id)])
		if not radpuerto_ids:
			radpuerto_val = {'name': vals['name'], 'radpuerto_id': do_id}
			radpuerto.create(cr, uid, radpuerto_val)
		return do_id

	def write(self, cr, uid, ids, vals, context={}):
		ret = super(oplog_do, self).write(cr, uid, ids, vals)
		if not 'name' in vals:
			return ret
		today = date.strftime(date.today(), '%Y-%m-%d %H:%M:%S')
		for id in ids:
			# Update oplog.nvaiero
			naviero = self.pool.get('oplog.naviero')
			naviero_val = {'name': vals['name'], 'fecha_naviero': today}
			naviero_ids = naviero.search(cr, uid, [('naviero_id', '=', id)])
			naviero.write(cr, uid, naviero_ids, naviero_val)
			# Update oplog.anticipo
			anticipo = self.pool.get('oplog.anticipo')
			anticipo_val = {'name': vals['name'], 'fecha_anticipo': today}
			anticipo_ids = anticipo.search(cr, uid, [('fondos_id', '=', id)])
			anticipo.write(cr, uid, anticipo_ids, anticipo_val)
			# Update oplog.radpuerto
			radpuerto = self.pool.get('oplog.radpuerto')
			radpuerto_val = {'name': vals['name']}
			radpuerto_ids = radpuerto.search(cr, uid, [('radpuerto_id', '=', id)])
			radpuerto.write(cr, uid, radpuerto_ids, radpuerto_val)
		return ret

oplog_do()

class oplog_pendiente(osv.osv):

#	def _aci_get(self, cr, uid, context={}):
#		obj = self.pool.get('res.partner')
#		cr.execute('select category_id from res_partner_category_rel where category_id=17')
#		category_ids = [x[0] for x in cr.fetchall()]
#		ids = obj.search(cr, uid, [('active', '=', 'true'), ('category_id', 'in', category_ids)])
#		res = obj.read(cr, uid, ids, ['name','active'], context)
#		return [(r['name'], r['name']) for r in res]

#domain="[ ('id','join','SQL') ]"
	def _getCreateUser(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			cr.execute('select u.name from oplog_pendiente d left join res_users u on COALESCE(d.write_uid, d.create_uid) = u.id where d.id=%d', (id,))
			uname = cr.fetchone()
			if uname and len(uname) > 0:
				res[id] = uname[0]
			#res[id] = 'admin'
		#print res
		return res

	def _sel_func(self, cr, uid, context={}): 
		obj = self.pool.get('oplog.do') 
		ids = obj.search(cr, uid, [('state','in',['apertura', 'tramite_dian', 'contabilidad'])])
		res = obj.read(cr, uid, ids, ['name', 'id'], context) 
		res = [(r['id'], r['name']) for r in res] 
		return res
	
	_name = "oplog.pendiente"
	_log_access = True
	_columns = {
		'name': fields.char('Pendiente', size=64),
		'pendiente': fields.text('Relación de documentos pendientes'),
		'pendiente_id': fields.many2one('oplog.do', 'DO#',size=32,required=True, select=True, selection=_sel_func),
		'ref_pdt': fields.char('Asunto', size=32, required=True),
		'user_id':fields.many2one('res.users','Responsable', size=20, readonly=True, select=True),
		'fecha_pendiente' : fields.datetime('Fecha Reg. Pendiente', required=True, readonly=True),
				}
		
	_defaults = { 

		'fecha_pendiente': lambda *a: time.strftime('%Y-%m-%d %H:%M:%S'),
		'user_id': lambda obj, cr, uid, context: uid,

		}
		
oplog_pendiente()

class oplog_naviero(osv.osv):
	def _getNaviera(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			do_obj = self.browse(cr, uid, id).naviero_id
			res[id] = do_obj.naviera
		#print res
		return res
	def _getBLM(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			do_obj = self.browse(cr, uid, id).naviero_id
			blm_names = []
			for blm in do_obj.codigo_blmaster:
				blm_names.append(blm.name)
			res[id] = ", ".join(blm_names)
		#print res
		return res
	def _getBlhNumber(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			res[id] = 0
			do_obj = self.browse(cr, uid, id).naviero_id
			retNums = do_obj._getBlhNumber(cr, uid, [do_obj.id], name, args)
			if retNums and retNums[do_obj.id]:
				res[id] = retNums[do_obj.id]
		#print res
		return res
	def _sel_func(self, cr, uid, context={}): 
		obj = self.pool.get('oplog.do') 
		ids = obj.search(cr, uid, [('state','in',['apertura', 'tramite_dian', 'contabilidad'])])
		res = obj.read(cr, uid, ids, ['name', 'id'], context) 
		res = [(r['id'], r['name']) for r in res] 
		return res
	# New write method to save user in 'user_id' field
	#def _getCreateUser(self, cr, uid, ids, name, args, context={}):
	#	res = {}
	#	for id in ids:
	#		cr.execute('select u.name from oplog_naviero d left join res_users u on COALESCE(d.write_uid, d.create_uid) = u.id where d.id=%d', (id,))
	#		uname = cr.fetchone()
	#		if uname and len(uname) > 0:
	#			res[id] = uname[0]
			#res[id] = 'admin'
		#print res
	#	return res
	
	def _getCreateUser(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			cr.execute('select u.name from oplog_naviero d left join res_users u on d.write_uid = u.id where d.id=%d', (id,))
			uname = cr.fetchone()
			if uname and len(uname) > 0:
				res[id] = uname[0]
			#res[id] = 'admin'
		#print res
		return res
	def _getUserSignature(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			cr.execute('select u.signature from oplog_naviero d left join res_users u on COALESCE(d.write_uid, d.create_uid) = u.id where d.id=%d', (id,))
			uname = cr.fetchone()
			if uname and len(uname) > 0:
				res[id] = uname[0]
		#print res
		return res
	_name = "oplog.naviero"
	_log_access = True
	_columns = {
		'name': fields.char('Naviero', size=64),
		'env_carta': fields.boolean('Confirmación envío carta'),
		'fecha_nav': fields.datetime('Fecha envío carta a naviera'),
		'rcv_carta': fields.boolean('Confirmación recibo carta'),
		'fecha_rcv': fields.datetime('Fecha cnf. recibo carta'),
		#'q_bhl': fields.integer('Cantidad de BLH'),
		'cont': fields.selection([('Carga suelta','Carga suelta'),('Contenedor','Contenedor')], 'Contenido', size=32),
		'naviera_carta': fields.function(_getNaviera, method=True, string='Naviera', type='char', size=32, readonly=True),
		'blm_carta': fields.function(_getBLM, method=True, string='B/L. Master', type='char', size=32, readonly=True),
		'blh_counter': fields.function(_getBlhNumber, method=True, string='Cantidad de BLH', type='integer', readonly=True),
		'naviero_id': fields.many2one('oplog.do', 'DO#',size=32, required=True, select=True, selection=_sel_func),
#		'naviero_id': fields.many2one('oplog.do', 'DO#',size=32, required=True, select=True),
		#'user_id':fields.many2one('res.users','Responsable', size=20, readonly=True, select=True),
		#'user_id': fields.function(_getCreateUser, method=True, type='char', string='Responsable'),
		'user_id': fields.function(_getCreateUser, method=True, type='char', string='Responsable'),
		'user_signature': fields.function(_getUserSignature, method=True, type='char', string='Signature'),
		'fecha_naviero' : fields.datetime('Fecha Reg. Naviero', required=True, readonly=True),
		}

	_defaults = {
		'fecha_naviero': lambda *a: time.strftime('%Y-%m-%d %H:%M:%S'),
		#'user_id': lambda obj, cr, uid, context: uid,
				}

oplog_naviero()

class oplog_anticipo(osv.osv):
	def _getTotal(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			anticipo = self.browse(cr, uid, id)
			res[id] = anticipo.instalaciones + anticipo.almacenaje + anticipo.montacargas + anticipo.pesaje + anticipo.traslado_vaciado + anticipo.traslaso_inspeccion + anticipo.deposito + anticipo.e_cargue + anticipo.documental + anticipo.vaciado_cont + anticipo.acarreo + anticipo.cargue + anticipo.mbl_nav + anticipo.hbl_sprc + anticipo.demora + anticipo.papeleria + anticipo.admon_cont + anticipo.dropoff
		#print res
		return res
	def _getACI(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			do_obj = self.browse(cr, uid, id).fondos_id
			res[id] = do_obj.aci
		#print res
		return res

	def _getVessel(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			do_obj = self.browse(cr, uid, id).fondos_id
			res[id] = do_obj.motonave
		#print res
		return res

	def _getPort(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			do_obj = self.browse(cr, uid, id).fondos_id
			res[id] = do_obj.puerto_llegada
		#print res
		return res

	def _getAciCode(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			do_obj = self.browse(cr, uid, id).fondos_id
			partner_obj = self.pool.get("res.partner")
			partner_id = partner_obj.search(cr, uid, [('name', '=', do_obj.aci)])
			if partner_id:
				#print partner_obj.browse(cr, uid, partner_id[0])
				res[id] = partner_obj.browse(cr, uid, partner_id[0]).ref
		#print res
		return res
	def _getBlhNumber(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			res[id] = 0
			do_obj = self.browse(cr, uid, id).fondos_id
			retNums = do_obj._getBlhNumber(cr, uid, [do_obj.id], name, args)
			if retNums and retNums[do_obj.id]:
				res[id] = retNums[do_obj.id]
		#print res
		return res
	def _getContainerNumber(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			res[id] = 0
			do_obj = self.browse(cr, uid, id).fondos_id
			retNums = do_obj._getContainerNumber(cr, uid, [do_obj.id], name, args)
			if retNums and retNums[do_obj.id]:
				res[id] = retNums[do_obj.id]
		#print res
		return res
	def _getContainerList(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			res[id] = 0
			do_obj = self.browse(cr, uid, id).fondos_id
			blm_ids = []
			for blm in do_obj.codigo_blmaster:
				blm_ids.append(blm.id)
			if blm:
				conts = blm._getContainerList(cr, uid, blm_ids, name, args)
				res[id] = ",".join(conts.values())
		#print res
		return res
	def _sel_func(self, cr, uid, context={}):
		obj = self.pool.get('oplog.do') 
		ids = obj.search(cr, uid, [('state','in',['apertura', 'tramite_dian', 'contabilidad']),('anticipos','=','1')])
		res = obj.read(cr, uid, ids, ['name', 'id'], context) 
		res = [(r['id'], r['name']) for r in res] 
		return res
	def _getCreateUser(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			cr.execute('select u.name from oplog_anticipo d left join res_users u on d.write_uid = u.id where d.id=%d', (id,))
			uname = cr.fetchone()
			if uname and len(uname) > 0:
				res[id] = uname[0]
		print res
		return res
	def _getUserSignature(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			cr.execute('select u.signature from oplog_naviero d left join res_users u on COALESCE(d.write_uid, d.create_uid) = u.id where d.id=%d', (id,))
			uname = cr.fetchone()
			if uname and len(uname) > 0:
				res[id] = uname[0]
		#print res
		return res
	_name = "oplog.anticipo"
	_log_access = True
	_columns = {
		'name': fields.char('Anticipo', size=64),
		'fecha_solicitud': fields.datetime('Fecha de solicitud'),
		'instalaciones': fields.integer('Uso de instalaciones'),
		'almacenaje': fields.integer('Almacenaje'),
		'montacargas': fields.integer('Montacargas para descargue'),
		'pesaje': fields.integer('Pesaje de mercancía'),
		'traslado_vaciado': fields.integer('Traslado de cont(s) a zona de vaciado'),
		'traslaso_inspeccion': fields.integer('Traslado de cont(s) para inspección'),
		'deposito': fields.integer('Depósito de contenedor(es)'),
		'e_cargue': fields.integer('Cargue específico cont(s) vacío en arrume negro'),
		'hbl_sprc': fields.integer('Desconsolidación HBL sistema SPRC'),
		'demora': fields.integer('Demora de contenedores'),
		'documental': fields.integer('Manejo documental naviero'),
		'papeleria': fields.integer('Papelería'),
		'admon_cont': fields.integer('Administración de Contenedor(es)'),
		'dropoff': fields.integer('DROP OFF'),		
		'vaciado_cont': fields.integer('Vaciado de contenedor(es)'),
		'acarreo': fields.integer('Acarreo local entrega cont(s) vacío'),
		'cargue': fields.integer('Cargue cont(s) vacío para su entrega'),
		'mbl_nav': fields.integer('Elaboración de MBL naviero'),
		'total_anticipo': fields.integer('Total anticipo'),
		'envio_fondos': fields.boolean('Recepción de fondos'),
		'fecha_recibido': fields.datetime('Fecha Recepción'),
		'fondos_id': fields.many2one('oplog.do', 'DO#', size=32,required=True, select=True, selection=_sel_func),
#		'fondos_id': fields.many2one('oplog.do', 'DO#', size=32, required=True, select=True),
		#'user_id': fields.many2one('res.users','Responsable', size=20, readonly=True, select=True),
		'user_id': fields.function(_getCreateUser, method=True, type='char', string='Responsable'),
		'user_signature': fields.function(_getUserSignature, method=True, type='char', string='Signature'),
		'fecha_anticipo': fields.datetime('Fecha Reg. Anticipo', required=True, readonly=True),
		'concept': fields.selection([('DROP OFF','DROP OFF'),('FACTURA SPRC','FACTURA SPRC'),('VACIADO','VACIADO')],'Concepto', size=32),
		'aci': fields.function(_getACI, method=True, string='ACI', readonly=True, type='char', size=45),
		'aci_code': fields.function(_getAciCode, method=True, string='NIT ACI', readonly=True, type='char', size=64),
		'total': fields.function(_getTotal, method=True, string='TOTAL', type="float", digits=(12,2), readonly=True),
		'vessel': fields.function(_getVessel, method=True, string='Motonave', type='char', size=20, readonly=True),
		'port': fields.function(_getPort, method=True, string='Puerto Arribo', type='char', size=32, readonly=True),
		'blh_counter': fields.function(_getBlhNumber, method=True, type='integer', string='#BLH'),
		'cont_counter': fields.function(_getContainerNumber, method=True, type='integer', string='#Contenedores'),
		'cont_list': fields.function(_getContainerList, method=True, type='text', string='Containers List'),
				}

	_defaults = {
		'fecha_anticipo': lambda *a: time.strftime('%Y-%m-%d %H:%M:%S'),
		#'user_id': lambda obj, cr, uid, context: uid,
				 }

oplog_anticipo()

class oplog_radpuerto(osv.osv):

	def _getAciCode2(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			do_obj = self.browse(cr, uid, id).radpuerto_id
			partner_obj = self.pool.get("res.partner")
			partner_id = partner_obj.search(cr, uid, [('name', '=', do_obj.aci)])
			if partner_id:
				print partner_obj.browse(cr, uid, partner_id[0])
				res[id] = partner_obj.browse(cr, uid, partner_id[0]).ref
		print res
		return res
	def _getPort(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			do_obj = self.browse(cr, uid, id).radpuerto_id
			res[id] = do_obj.puerto_llegada
		#print res
		return res
	def _getModalidad(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			do_obj = self.browse(cr, uid, id).radpuerto_id
			res[id] = do_obj.regimen
		#print res
		return res
	def _getBlhNumber(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			res[id] = 0
			do_obj = self.browse(cr, uid, id).radpuerto_id
			retNums = do_obj._getBlhNumber(cr, uid, [do_obj.id], name, args)
			if retNums and retNums[do_obj.id]:
				res[id] = retNums[do_obj.id]
		#print res
		return res
	def _getContainerNumber(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			res[id] = 0
			do_obj = self.browse(cr, uid, id).radpuerto_id
			retNums = do_obj._getContainerNumber(cr, uid, [do_obj.id], name, args)
			if retNums and retNums[do_obj.id]:
				res[id] = retNums[do_obj.id]
		#print res
		return res
	def _sel_func(self, cr, uid, context={}): 
		obj = self.pool.get('oplog.do') 
		#ids = obj.search(cr, uid, [('state','=','apertura')])
		ids = obj.search(cr, uid, [('state','in',['apertura', 'tramite_dian', 'contabilidad'])])
		res = obj.read(cr, uid, ids, ['name', 'id'], context) 
		res = [(r['id'], r['name']) for r in res] 
		return res
	def _getCreateUser(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			cr.execute('select u.name from oplog_radpuerto d left join res_users u on d.write_uid = u.id where d.id=%d', (id,))
			uname = cr.fetchone()
			if uname and len(uname) > 0:
				res[id] = uname[0]
		#print res
		return res
	def _getUserSignature(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			cr.execute('select u.name from oplog_radpuerto d left join res_users u on COALESCE(d.write_uid, d.create_uid) = u.id where d.id=%d', (id,))
			uname = cr.fetchone()
			if uname and len(uname) > 0:
				res[id] = uname[0]
		#print res
		return res
	_name = "oplog.radpuerto"
	_log_access = True
	_columns = {
		'name': fields.char('Radpuerto', size=64),
		'aci_code2': fields.function(_getAciCode2, method=True, string='NIT', type='char', size=64),
		'state': fields.function(_getPort, method=True, string='Puerto Arribo', type='char', size=32, readonly=True),
		'modalidad_rdc': fields.function(_getModalidad, method=True, string='Modalidad', type='char', size=32, readonly=True),
		# Show only if puerto_llegada="S.P.R.C"
		#'no_hbl': fields.integer('No. HBL(s)', states={'S.P.R.C.':[('readonly',False)],'MUELLES EL BOSQUE':[('readonly',True)],'CONTECAR':[('readonly',True)]}),
		#'solc_fact': fields.boolean('Solicitud factura', states={'S.P.R.C.':[('readonly',False)],'MUELLES EL BOSQUE':[('readonly',True)],'CONTECAR':[('readonly',True)]}),
		'fecha_solc_fact': fields.datetime('Fecha Solicitud de Factura', states={'S.P.R.C.':[('readonly',False)],'MUELLES EL BOSQUE':[('readonly',True)],'CONTECAR':[('readonly',True)]}), 
		#'exp_fact': fields.boolean('Expedición factura', states={'S.P.R.C.':[('readonly',False)],'MUELLES EL BOSQUE':[('readonly',True)],'CONTECAR':[('readonly',True)]}),
		'factura': fields.char('Factura No.', size=64, states={'S.P.R.C.':[('readonly',False)],'MUELLES EL BOSQUE':[('readonly',True)],'CONTECAR':[('readonly',True)]}),
		'fecha_factura': fields.datetime('Fecha expedición factura', states={'S.P.R.C.':[('readonly',False)],'MUELLES EL BOSQUE':[('readonly',True)],'CONTECAR':[('readonly',True)]}), 
		#'fact_pago': fields.boolean('Pago factura', states={'S.P.R.C.':[('readonly',False)],'MUELLES EL BOSQUE':[('readonly',True)],'CONTECAR':[('readonly',True)]}),
		'fecha_radpto': fields.datetime('Fecha pago factura', states={'S.P.R.C.':[('readonly',False)],'MUELLES EL BOSQUE':[('readonly',True)],'CONTECAR':[('readonly',True)]}),
		#
		#'env_rad_pto': fields.boolean('Envío carta de radicación'),
		# 'fecha_env_radicado': fields.datetime('Fecha envío carta'),
		#'rad_pto': fields.boolean('Radicado en puerto'),
		'fecha_radicado': fields.datetime('Fecha Radicación Puerto'),
		'radpuerto_id': fields.many2one('oplog.do', 'DO#',size=32,required=True, select=True, selection=_sel_func),
#		'radpuerto_id': fields.many2one('oplog.do', 'DO#',size=32,required=True, select=True, domain=[('state', 'in', ['apertura', 'tramite_dian', 'contabilidad'])]),
#		'radpuerto_id': fields.many2one('oplog.do', 'DO#',size=32,required=True, select=True),
		#'user_id':fields.many2one('res.users','Responsable', size=20, readonly=True, select=True),
		'user_id': fields.function(_getCreateUser, method=True, type='char', string='Responsable'),
		'user_signature': fields.function(_getUserSignature, method=True, type='char', string='Signature'),
		'fecha_radpuerto' : fields.datetime('Fecha Reg. Radicación Puerto'),
		'blh_counter': fields.function(_getBlhNumber, method=True, type='integer', string='# BLH', readonly=True),
		'cont_counter': fields.function(_getContainerNumber, method=True, type='integer', string='# Contenedores'),
		}
	
	_defaults = { 

		'fecha_radpuerto': lambda *a: time.strftime('%Y-%m-%d %H:%M:%S'),
		#'user_id': lambda obj, cr, uid, context: uid,

				}

oplog_radpuerto()

class oplog_blmaster(osv.osv):

	def _getDO(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			do_obj = self.browse(cr, uid, id).do_id
			res[id] = do_obj.name
		#print res
		return res
	def _searchByDO(self, cr, uid, obj, name, args, context={}):
		if not len(args):
			return []
		res = []
		# print obj, name, args, context
		do = self.pool.get("oplog.do")
		for f, o, v in args:
			do_ids = do.search(cr, uid, [('name', o, v)])
			if len(do_ids):
				res.append(('do_id','in',do_ids))
		if not len(res):
			return [('id', '=', 0)]
		# print res
		return res
	def _searchByACI(self, cr, uid, obj, name, args, context={}):
		if not len(args):
			return []
		res = []
		# print obj, name, args, context
		do = self.pool.get("oplog.do")
		for f, o, v in args:
			do_ids = do.search(cr, uid, [('aci', o, v)])
			if len(do_ids):
				res.append(('do_id','in',do_ids))
		if not len(res):
			return [('id', '=', 0)]
		# print res
		return res
	def _searchByRef(self, cr, uid, obj, name, args, context={}):
		if not len(args):
			return []
		res = []
		# print obj, name, args, context
		do = self.pool.get("oplog.do")
		for f, o, v in args:
			do_ids = do.search(cr, uid, [('referencia', o, v)])
			if len(do_ids):
				res.append(('do_id','in',do_ids))
		if not len(res):
			return [('id', '=', 0)]
		# print res
		return res
	def _searchByBlh(self, cr, uid, obj, name, args, context={}):
		if not len(args):
			return []
		res = []
		# print obj, name, args, context
		blhijo = self.pool.get("oplog.blhijo")
		for f, o, v in args:
			blh_ids = blhijo.search(cr, uid, [('name', o, v)])
			blm_ids = []
			for blh_id in blh_ids:
				blhijo_obj = blhijo.browse(cr, uid, blh_id)
				if blhijo_obj and blhijo_obj.blmaster_id:
					blm_ids.append(blhijo_obj.blmaster_id.id)
			if len(blm_ids):
				res.append(('id','in',blm_ids))
		if not len(res):
			return [('id', '=', 0)]
		# print res
		return res
	# def _searchByBlhCnt(self, cr, uid, obj, name, args, context={}):
		# if not len(args):
			# return []
		# res = []
		# # print obj, name, args, context
		# blhijo = self.pool.get("oplog.blhijo")
		# for f, o, v in args:
			# blh_ids = blhijo.search(cr, uid, [('contenedor_blh', o, v)])
			# blm_ids = []
			# for blh_id in blh_ids:
				# blhijo_obj = blhijo.browse(cr, uid, blh_id)
				# if blhijo_obj and blhijo_obj.blmaster_id:
					# blm_ids.append(blhijo_obj.blmaster_id.id)
			# if len(blm_ids):
				# res.append(('id','in',blm_ids))
		# if not len(res):
			# return [('id', '=', 0)]
		# # print res
		# return res
	def _searchByBlhCnt(self, cr, uid, obj, name, args, context={}):
		if not len(args):
			return []
		res = []
		contenedor = self.pool.get("oplog.contenedor")
		blhijo = self.pool.get("oplog.blhijo")
		for f, o, v in args:
			contenedor_ids = contenedor.search(cr, uid, [('name', o, v)])
			# print contenedor_ids
			blh_ids = []
			blm_ids = []
			for contenedor_obj in contenedor.browse(cr, uid, contenedor_ids):
				blh_ids.append(contenedor_obj.blh_id.id)
			# print blh_ids
			for blh_id in blh_ids:
				blhijo_obj = blhijo.browse(cr, uid, blh_id)
				if blhijo_obj and blhijo_obj.blmaster_id:
					blm_ids.append(blhijo_obj.blmaster_id.id)
			# print blm_ids
			if len(blm_ids):
				res.append(('id','in',blm_ids))

		if not len(res):
			return [('id', '=', 0)]
		# print res
		return res
	def _searchByBlhCsg(self, cr, uid, obj, name, args, context={}):
		if not len(args):
			return []
		res = []
		# print obj, name, args, context
		blhijo = self.pool.get("oplog.blhijo")
		for f, o, v in args:
			blh_ids = blhijo.search(cr, uid, [('consig_blh', o, v)])
			blm_ids = []
			for blh_id in blh_ids:
				blhijo_obj = blhijo.browse(cr, uid, blh_id)
				if blhijo_obj and blhijo_obj.blmaster_id:
					blm_ids.append(blhijo_obj.blmaster_id.id)
			if len(blm_ids):
				res.append(('id','in',blm_ids))
		if not len(res):
			return [('id', '=', 0)]
		# print res
		return res
	def _getACI(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			do_obj = self.browse(cr, uid, id).do_id
			res[id] = do_obj.aci
		#print res
		return res
	def _getRef(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			do_obj = self.browse(cr, uid, id).do_id
			res[id] = do_obj.referencia
		#print res
		return res
	def _getBlh(self, cr, uid, ids, name, args, context={}):
			res = {}
			blhijo = self.pool.get("oplog.blhijo")
			for id in ids:
				res[id] = None
				blhijo_ids = blhijo.search(cr, uid, [('blmaster_id', '=', id)])
				blhijo_obj = None
				if blhijo_ids:
					blhijo_obj = blhijo.browse(cr, uid, blhijo_ids[0])
				if blhijo_obj:
					res[id] = blhijo_obj.name
			return res
	# def _getBlhCnt(self, cr, uid, ids, name, args, context={}):
			# res = {}
			# blhijo = self.pool.get("oplog.blhijo")
			# for id in ids:
				# res[id] = None
				# blhijo_ids = blhijo.search(cr, uid, [('blmaster_id', '=', id)])
				# blhijo_obj = None
				# if blhijo_ids:
					# blhijo_obj = blhijo.browse(cr, uid, blhijo_ids[0])
				# if blhijo_obj:
					# res[id] = blhijo_obj.contenedor_blh
			# return res

	def _getBlhCsg(self, cr, uid, ids, name, args, context={}):
			res = {}
			blhijo = self.pool.get("oplog.blhijo")
			for id in ids:
				res[id] = None
				blhijo_ids = blhijo.search(cr, uid, [('blmaster_id', '=', id)])
				blhijo_obj = None
				if blhijo_ids:
					blhijo_obj = blhijo.browse(cr, uid, blhijo_ids[0])
				if blhijo_obj:
					res[id] = blhijo_obj.consig_blh
			return res

	def _getTotalWeightOfBLH(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			res[id] = 0
			blm = self.browse(cr, uid, id)
			for blh in blm.codigo_blhijo:
				for pa in blh.paquetes_id:
					res[id] += pa.peso_paquetes
				# res[id] += blh.peso_paquetes
		#print res
		return res
#	def button_dummy(self, cr, uid, ids, context={}):
#		return True
	def _getTotalQtyOfBLH(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			res[id] = 0
			blm = self.browse(cr, uid, id)
			for blh in blm.codigo_blhijo:
				for pa in blh.paquetes_id:
					res[id] += pa.cantidad
				# res[id] += blh.cantidad
		#print res
		return res
	def _getBlhNumber(self, cr, uid, ids, name, args, context={}):
		res = {}
		blhijo = self.pool.get("oplog.blhijo")
		for id in ids:
			res[id] = 0
			blhijo_ids = blhijo.search(cr, uid, [('blmaster_id', '=', id)])
			if blhijo_ids:
				res[id] = len(blhijo_ids)
		return res
	def _getContainerNumber(self, cr, uid, ids, name, args, context={}):
		res = {}
		contenedor = self.pool.get("oplog.contenedor")
		blhijo = self.pool.get("oplog.blhijo")
		for id in ids:
			res[id] = 0
			blhijo_ids = blhijo.search(cr, uid, [('blmaster_id', '=', id)])
			contenedor_ids = []
			if blhijo_ids and len(blhijo_ids) > 0:
				contenedor_ids = contenedor.search(cr, uid, [('blh_id', 'in', blhijo_ids)])
			if contenedor_ids:
				res[id] = len(contenedor_ids)
		return res
	def _getContainerList(self, cr, uid, ids, name, args, context={}):
		res = {}
		contenedor = self.pool.get("oplog.contenedor")
		blhijo = self.pool.get("oplog.blhijo")
		for id in ids:
			res[id] = ''
			cont_name_list = []
			blhijo_ids = blhijo.search(cr, uid, [('blmaster_id', '=', id)])
			contenedor_ids = []
			if blhijo_ids and len(blhijo_ids) > 0:
				contenedor_ids = contenedor.search(cr, uid, [('blh_id', 'in', blhijo_ids)])
			if contenedor_ids and len(contenedor_ids) > 0:
				contenedor_names = contenedor.read(cr, uid, contenedor_ids, ['name'], context)
				for cont_name in contenedor_names:
					cont_name_list.append(cont_name['name'])
					res[id] = ', '.join(cont_name_list)
		return res
	def _getBlhList(self, cr, uid, ids, name, args, context={}):
		res = {}
		blhijo = self.pool.get("oplog.blhijo")
		for id in ids:
			res[id] = ''
			blh_name_list = []
			blhijo_ids = blhijo.search(cr, uid, [('blmaster_id', '=', id)])
			if blhijo_ids and len(blhijo_ids) > 0:
				blh_names = blhijo.read(cr, uid, blhijo_ids, ['name'], context)
				for blh_name in blh_names:
					blh_name_list.append(blh_name['name'])
				res[id] = ', '.join(blh_name_list)
		return res
	def _getShipperPart(self, cr, uid, ids, name, args, context={}):
		res = {}
		blhijo = self.pool.get("oplog.blhijo")
		for id in ids:
			res[id] = ''
			do_obj = self.browse(cr, uid, id).do_id
			vaciado_check = do_obj.regimen in ['VACIADO','Vaciado']
			radicacion_check = do_obj.regimen in ['RADICACION','Radicacion']
			rows = []
			for blh in self.browse(cr, uid, id).codigo_blhijo:
				for pa in blh.paquetes_id:
					cols = []
					if vaciado_check:
						if blh.consig_blh:
							cols.append(blh.consig_blh)
						else:
							cols.append('')
					elif radicacion_check:
						cols.append(blh._getContainerList(cr, uid, [blh.id], name, args, context)[blh.id])
					cols.append("%d/%s" % (blh.cantidad, pa.clase_paquetes))
					if pa.descripcion_paquetes:
						cols.append(pa.descripcion_paquetes)
					else:
						cols.append('')
					cols.append(str(pa.peso_paquetes))
					#print cols
					temp = ',\t'.join(cols)
					rows.append(temp)
			if rows:
				#rows.insert(0, 'MARKS AND NUMBERS,\tNo. PACKAGES/CNTRS,\tDESCRIPCTION OF PACKAGES AND GOODS,\tGROSS WEIGHT')
				res[id] = '\n'.join(rows)
			else:
				res[id] = ''
		return res
	def _groupContainers(self, cr, uid, ids, name, args, context={}):
		res = {}
		contenedor = self.pool.get("oplog.contenedor")
		blhijo = self.pool.get("oplog.blhijo")
		for id in ids:
			res[id] = ''
			grp_cont = {}
			cont_name_list = []
			blhijo_ids = blhijo.search(cr, uid, [('blmaster_id', '=', id)])
			contenedor_ids = []
			for blh_id in blhijo_ids:
				contenedor_ids = contenedor.search(cr, uid, [('blh_id', '=', blh_id)])
				for cont_id in contenedor_ids:
					if cont_id in grp_cont:
						if not blh_id in grp_cont[cont_id]:
							grp_cont[cont_id].append(blh_id)
					else:
						grp_cont[cont_id] = [blh_id]
			# for k, v in grp_cont.items():
				# contenedor_names = contenedor.read(cr, uid, [k], ['name'], context)
				# if len(contenedor_names) > 0:
					# text = "Contenedor: [%s]" %  contenedor_names[0]['name']
					# res[id] += text + "\n"
					# for blh_id in v:
						# blh_names = blhijo.read(cr, uid, [blh_id], ['name'], context)
						# if len(blh_names) > 0:
							# text = "  BLH: [%s]" % blh_names[0]['name']
							# res[id] += text + "\n"
					# res[id] += "\n"
			grp_cont2 = {}
			for k, v in grp_cont.items():
				contenedor_names = contenedor.read(cr, uid, [k], ['name'], context)
				if len(contenedor_names) > 0:
					cont_name = contenedor_names[0]['name']
					if cont_name in grp_cont2:
						grp_cont2[cont_name] += grp_cont[k]
					else:
						grp_cont2[cont_name] = grp_cont[k]
			for k, v in grp_cont2.items():
				text = "Contenedor: [%s]" %  k
				res[id] += text + "\n"
				for blh_id in v:
					blh_names = blhijo.read(cr, uid, [blh_id], ['name'], context)
					if len(blh_names) > 0:
						text = "  BLH: [%s]" % blh_names[0]['name']
						res[id] += text + "\n"
				res[id] += "\n"
		#print res
		return res

	_name = 'oplog.blmaster'
	_log_access = True
	_columns = {
		'name': fields.char('Número B/L.-M', size=64, required=True, select=True),
		#'contenido': fields.char('Contenido', size=255),
		'consig_blm': fields.char('Consignatario', size=64),
		'dir_consig_blm': fields.char('Dir. Consignatario', size=64),
		'consdor_blm': fields.char('Consignador', size=64),
		'dir_consdor_blm': fields.char('Dir. Consignador', size=64),
		# Show information of PARTICULAR FURNISHED BY SHIPPER in BL(s) document attached
		# To do it consolidate this fields by lines (each line by HBL and his HBL's packages -oplog.paquetes-) in one text field in this way:
		#  Firts column "MARKS AND NUMBERS": For RADICACION use 'blhijo.contenedor_id' (list containers name); for "VACIADO" use 'blhijo.consig_blh'
		#  Second column "No. PACKAGES/CNTRS." and "DESCRIPCTION OF PACKAGES AND GOODS":
		#  Concatenate 'oplog.paquetes.cantidad' + 'oplog.paquetes.clase_paquetes' + 'oplog.paquetes.descripcion_paquetes'
		#  Third column "GROSS WEIGHT":  'oplog.paquetes.peso_paquetes'
		'shipper_part': fields.function(_getShipperPart, method=True, string='shipper_part', type='text'),
		#'clase_embalaje': fields.selection([('BARRIL(ES)','BARRIL'),('BIDON(ES)','BIDON'),('BOBINA(S)','BOBINA'),
		#('BOLSA(S)','BOLSA'),('BOTELLA(S)','BOTELLA'),('BULTO(S)','BULTO'),('CAJA(S)','CAJA'),
		#('CAJA(S) DE MADERA','CAJA DE MADERA'),('CAJA(S) DE CARTON','CAJA DE CARTON'),('CARRETE(S)','CARRETE'),
		#('CARTON(ES)','CARTONES'),('CONTENEDOR(ES)','CONTENEDOR'),('FARDO(S)','FARDO'),('FRASCO(S)','FRASCO'),('GARRAFON(ES)','GARRAFON'),
		#('JARRO(S)','JARRO'),('LINGOTE(S)','LINGOTE'),('PALLET(S)','PALLET'),('PAQUETE(S)','PAQUETE'),('PIEZA(S)','PIEZA'),
		#('ROLLO(S)','ROLLO'),('SACO(S)','SACO'),('SKID(S)','SKID'),('TAMBOR(ES)','TAMBOR'),('TONEL(ES)','TONEL'),('TUBO(S)','TUBO')],
		#'Clase de embalaje', size=32),
		#'peso': fields.float('Peso (Kg.)', digits=(12,3)),
		# /End field consolidation
		# 'cantidad' and 'peso' now come from new class oplog.paquetes
		'cantidad': fields.function(_getTotalQtyOfBLH, method=True, string='Cantidad Total', type="integer"),
		'peso': fields.function(_getTotalWeightOfBLH, method=True, string='Peso Total (Kg.)', type="float", digits=(12,3)),
		# /End 'cantidad' and 'peso'
		'fh_ems_blm': fields.date('Fecha de corte'),
		'do_blm': fields.function(_getDO, method=True, string='DO', type='char', size=32, readonly=True, fnct_search=_searchByDO),
		'do_aci': fields.function(_getACI, method=True, string='ACI', type='char', size=32, readonly=True, fnct_search=_searchByACI),
		'do_ref': fields.function(_getRef, method=True, string='Referencia', type='char', size=32, readonly=True, fnct_search=_searchByRef),
		'blh_name': fields.function(_getBlh, method=True, string='BLH', type='char', size=32, readonly=True, fnct_search=_searchByBlh),
		# 'blh_cnt': fields.function(_getBlhCnt, method=True, string='Contenedor', type='char', size=32, readonly=True, fnct_search=_searchByBlhCnt),
		'blh_csg': fields.function(_getBlhCsg, method=True, string='Consignatario', type='char', size=32, readonly=True, fnct_search=_searchByBlhCsg),
		# 'contenedor_name': fields.function(_getContenedor, method=True, string='Contenedor', type='char', size=32, readonly=True, fnct_search=_searchByContenedor),
		#'contenedor_blm': fields.text('Contenedor(es)', required=True),
		'contenedor_blm': fields.function(_groupContainers, method=True, string='Contenedor(es)', type='text'),
		#------------------------------------
		# RELATIONAL FIELDS
		#------------------------------------
		'do_id': fields.many2one('oplog.do','#DO', required=True, select=True),
		#'contenedor_id': fields.one2many('oplog.contenedor', 'blm_id', 'Contenedor', select=True),
		# The field is saved "null"; use a method to search for blhijo related and write it.
		'codigo_blhijo': fields.one2many('oplog.blhijo', 'blmaster_id', 'Número B/L Hijo', required=True, select=True),
		# 
		#'state': fields.char('Estado', size=16),
		'fecha_blm': fields.datetime('Fecha BLM', required=True, readonly=True),
		'blh_counter': fields.function(_getBlhNumber, method=True, type='integer', string='#BLH'),
		'cont_counter': fields.function(_getContainerNumber, method=True, type='integer', string='#Containers'),
		'cont_list': fields.function(_getContainerList, method=True, type='char', string='Contenedor', fnct_search=_searchByBlhCnt),
		'blh_list': fields.function(_getBlhList, method=True, type='char', string='BLH List'),
				}

	_defaults = {
		'fecha_blm': lambda *a: time.strftime('%Y-%m-%d %H:%M:%S'),
				}

oplog_blmaster()

class oplog_blhijo(osv.osv):
	def _sel_func(self, cr, uid, context={}): 
		obj = self.pool.get('oplog.blmaster') 
		ids = obj.search(cr, uid, [('do_id.state','=','apertura')])
		res = obj.read(cr, uid, ids, ['name', 'id'], context) 
		res = [(r['id'], r['name']) for r in res] 
		return res
	def _getPiezas(self, cr, uid, ids, name, args, context={}):
		res = {}
		contenedor = self.pool.get("oplog.contenedor")
		blm = self.pool.get("oplog.blmaster")
		do = self.pool.get("oplog.do")
		for id in ids:
			res[id] = ''
			blh_obj = self.browse(cr, uid, id)
			blm_obj = blm.browse(cr, uid, blh_obj.blmaster_id.id)
			do_obj = do.browse(cr, uid, blm_obj.do_id.id)
			#res[id] = do_obj.regimen
			if do_obj and do_obj.regimen in ['RADICACION','Radicacion']:
				contenedor_ids = contenedor.search(cr, uid, [('blh_id', '=', id)])
				if contenedor_ids and len(contenedor_ids) > 0:
					contNums = len(contenedor_ids)
					cont_tamano = contenedor.read(cr, uid, contenedor_ids, ['tamano'], context)
					res[id] = "%d X %s" % (contNums, cont_tamano[0]['tamano'])
			elif do_obj and do_obj.regimen in ['VACIADO','Vaciado']:
				#res[id] = "%d X %s" % (blh_obj.cantidad, blh_obj.clase_blh)
				l = []
				for pa in blh_obj.paquetes_id:
					l.append("%d X %s" % (pa.cantidad, pa.clase_paquetes))
				res[id] = ', '.join(l)
		print res
		return res
	def _getContainerList(self, cr, uid, ids, name, args, context={}):
		res = {}
		contenedor = self.pool.get("oplog.contenedor")
		for id in ids:
			res[id] = ''
			blh_obj = self.browse(cr, uid, id)
			cont_name_list = []
			contenedor_ids = []
			contenedor_ids = contenedor.search(cr, uid, [('blh_id', '=', blh_obj.id)])
			if contenedor_ids and len(contenedor_ids) > 0:
				contenedor_names = contenedor.read(cr, uid, contenedor_ids, ['name'], context)
				for cont_name in contenedor_names:
					cont_name_list.append(cont_name['name'])
					res[id] = ', '.join(cont_name_list)
			return res
	def _getPeso(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			res[id] = 0
			blh = self.browse(cr, uid, id)
			for pa in blh.paquetes_id:
				res[id] += pa.peso_paquetes
		return res
#	def button_dummy(self, cr, uid, ids, context={}):
#		return True
	def _getCantidad(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			res[id] = 0
			blh = self.browse(cr, uid, id)
			for pa in blh.paquetes_id:
				res[id] += pa.cantidad
		return res
	_name = 'oplog.blhijo'
	_log_access = True
	_columns = {
		'name': fields.char('Número B/L Hijo', size=64, required=True, select=True),
		'consig_blh': fields.char('Consignatario', size=128),
		'dir_consig_blh': fields.char('Dir. Consignatario', size=128),
		'consid_blh': fields.char('Consignador', size=128),
		'dir_consid_blh': fields.char('Dir. Consignador', size=128),
		'origen': fields.char('Origen', size=32, required=True),
		'pais_blh': fields.many2one('res.country', 'País'),
		#'contenido_bhl': fields.char('Contenido', size=255),
		# The following fields was migrated to oplog.paquetes relationed by 'paquetes_id' (see in #Other fields below)
		# 'cantidad': fields.integer('Cantidad'),
		# 'clase_blh': fields.selection([('BARRIL(ES)','BARRIL'),('BIDON(ES)','BIDON'),('BOBINA(S)','BOBINA'),
		# ('BOLSA(S)','BOLSA'),('BOTELLA(S)','BOTELLA'),('BULTO(S)','BULTO'),('CAJA(S)','CAJA'),
		# ('CAJA(S) DE MADERA','CAJA DE MADERA'),('CAJA(S) DE CARTON','CAJA DE CARTON'),('CARRETE(S)','CARRETE'),
		# ('CARTON(ES)','CARTONES'),('CONTENEDOR(ES)','CONTENEDOR'),('FARDO(S)','FARDO'),('FRASCO(S)','FRASCO'),('GARRAFON(ES)','GARRAFON'),
		# ('JARRO(S)','JARRO'),('LINGOTE(S)','LINGOTE'),('PALLET(S)','PALLET'),('PAQUETE(S)','PAQUETE'),('PIEZA(S)','PIEZA'),
		# ('ROLLO(S)','ROLLO'),('SACO(S)','SACO'),('SKID(S)','SKID'),('TAMBOR(ES)','TAMBOR'),('TONEL(ES)','TONEL'),('TUBO(S)','TUBO')],
		# 'Clase de embalaje', required=True, size=32, select=True),
		# 'peso_paquetes': fields.float('Peso Paq.(Kg.)', digits=(12,3)),
		# 'descripcion_paquetes': fields.text('Desc. de Paquetes', size=1000),
		# / End of migrated fields.
		'cantidad': fields.function(_getCantidad, method=True, type='integer', string='Cantidad'),
		'peso_paquetes': fields.function(_getPeso, method=True, type='float', string='Peso Paq.(Kg.)'),
		'fh_ems_blh': fields.date('Fecha de corte'),
		# Liberation fields
		'aut_lib' : fields.boolean('Autorizado para liberar'),
		'fh_aut': fields.datetime('Fecha y hora de la autorización'),
		'liberado' : fields.boolean('Liberado'),
		'fh_lib': fields.datetime('Fecha Liberación SIA'),
		'nombre': fields.char('Nombre', size=32),
		'cc': fields.char('C.C.#', size=32),
		'sia': fields.char('SIA', size=32),
		# Other fields
		'contenedor_id': fields.one2many('oplog.contenedor', 'blh_id', 'Contenedor', required=True, select=True),
		'paquetes_id': fields.one2many('oplog.paquetes', 'blh_id', 'Paquetes', required=True, select=True),
		'contenedor_blh': fields.char('Contenedor', size=255),
		'colilla_vac': fields.binary('Colilla'),
		# Relational fileds
		'blmaster_id': fields.many2one('oplog.blmaster','B/L.-M Asociado', required=True, select=True),
		#'blmaster_id': fields.many2one('oplog.blmaster','B/L.-M Asociado', select=True),
		#'blh_do_id': fields.many2one('oplog.do','BLH-DO', select=True),
		#'contenedor_ids': fields.many2many('oplog.contenedor','oplog_bl_conten_rel','child_id','parent_id','Contenedor'),
		# User and record date fields
		#'user_id':fields.many2one('res.users','Responsable', size=20, readonly=True, select=True),
		'fecha_blh': fields.datetime('Fecha BLH', required=True, readonly=True),
		'piezas': fields.function(_getPiezas, method=True, type='char', string='#PIEZAS'),
				}

	_defaults = {
		'fecha_blh': lambda *a: time.strftime('%Y-%m-%d %H:%M:%S'),
		#'user_id': lambda obj, cr, uid, context: uid,
				}

oplog_blhijo()

class oplog_paquetes(osv.osv):
	_name = 'oplog.paquetes'
	_description = 'Paquetes'
	_log_access = True
	_columns = {
		'name': fields.char('Paquete',size = 14, select=True),
		'cantidad': fields.integer('Cantidad', required=True),
		'clase_paquetes': fields.selection([('BARRIL(ES)','BARRIL'),('BIDON(ES)','BIDON'),('BOBINA(S)','BOBINA'),
		('BOLSA(S)','BOLSA'),('BOTELLA(S)','BOTELLA'),('BULTO(S)','BULTO'),('CAJA(S)','CAJA'),
		('CAJA(S) DE MADERA','CAJA DE MADERA'),('CAJA(S) DE CARTON','CAJA DE CARTON'),('CARRETE(S)','CARRETE'),
		('CARTON(ES)','CARTONES'),('CONTENEDOR(ES)','CONTENEDOR'),('FARDO(S)','FARDO'),('FRASCO(S)','FRASCO'),('GARRAFON(ES)','GARRAFON'),
		('JARRO(S)','JARRO'),('LINGOTE(S)','LINGOTE'),('PALLET(S)','PALLET'),('PAQUETE(S)','PAQUETE'),('PIEZA(S)','PIEZA'),
		('ROLLO(S)','ROLLO'),('SACO(S)','SACO'),('SKID(S)','SKID'),('TAMBOR(ES)','TAMBOR'),('TONEL(ES)','TONEL'),('TUBO(S)','TUBO')],
		'Clase de embalaje', required=True, size=32, select=True),
		'peso_paquetes': fields.float('Peso Paq.(Kg.)', digits=(12,3)),
		'descripcion_paquetes': fields.text('Desc. de Paquetes', size=1000),
		'blh_id': fields.many2one('oplog.blhijo','Número B/L.Hijo', required=True, select=True),
		'fecha_pqt' : fields.datetime('Fecha CNT', required=True, readonly=True),
				}

	_defaults = {
		'fecha_pqt': lambda *a: time.strftime('%Y-%m-%d %H:%M:%S'),

				}

oplog_paquetes()

class oplog_contenedor(osv.osv):
	_name = 'oplog.contenedor'
	_description = 'Contenedor'
	_log_access = True
	_columns = {
		'name': fields.char('Contenedor',size = 14, select=True),
		'estado': fields.selection([('ok','OK'),('danado_en_puertas','Daño en Puertas'),('puntas_oxidadas','Puntas Oxidadas'),('averiado','Averiado')],'Estado'),
		'tipo':fields.selection([('dry','Dry'),('hard_top','Hard Top'),('open_top','Open Top'),('open_side','Open Side'),
		('plataforma','Plataforma'),('flat_rack','Flat Rack'),('ventilado','Ventilado'),('fantainer_aislado','Fantainer Aislado'),('reefer','Reefer'),
		('bulktainer','Bulktainer'),('isotanque','Isotanque'),('conair','Conair'),
		('media_altura','Media Altura')],'Tipo Contenedor', required=True, select=True),
		'tamano': fields.selection([('20 STD','20´ Pies Estándar'),('40 STD','40´ Pies Estándar'),('40 HC','40´ Pies High Cube'),('45 HC','45´ Pies High Cube')],'Tamaño', required=True),
		'no_sello': fields.char('Numero Sello', size=20),
		#'blm_id': fields.many2one('oplog.blmaster','Número B/L.Master', required=True, select=True),
		#'blm_id': fields.many2one('oplog.blmaster','Número B/L.Master', select=True),
		'blh_id': fields.many2one('oplog.blhijo','Número B/L.Hijo', required=True, select=True),
		#'contenedor_do_id': fields.many2one('oplog.do','BLH-DO', select=True),
		'fecha_cnt' : fields.datetime('Fecha CNT', required=True, readonly=True),
				}

	_defaults = {
		'fecha_cnt': lambda *a: time.strftime('%Y-%m-%d %H:%M:%S'),

				}

oplog_contenedor()

class oplog_dian(osv.osv):
	#def create(self, cr, uid, vals, context={}):
		#hora_fin = vals["hora_fin"]
		#ret = False
		#if hora_fin:
			#temp = time.strptime(hora_fin, '%Y-%m-%d %H:%M:%S')
			#theDate = date(temp[0], temp[1], temp[2]) + timedelta(days=5)
			#facturacion_val = {
				#'name':vals["name"], 
				#'fecha_finalizacion':hora_fin, 
				#'fecha_vencimiento': "%s %s" % (str(theDate), time.strftime("%H:%M:%S", temp)),
				#'facturacion_id':vals["do_ids"],
				#}
			#ret = self.pool.get('oplog.facturacion').create(cr, uid, facturacion_val)
		#return ret and super(oplog_dian, self).create(cr, uid, vals)

	def write(self, cr, uid, ids, vals, context={}):
		hora_fin = "hora_fin" in vals and vals["hora_fin"] or None
		ret = True
		if hora_fin:
			dian_obj = self.browse(cr, uid, ids[0])
			temp = time.strptime(hora_fin, '%Y-%m-%d %H:%M:%S')
			theDate = date(temp[0], temp[1], temp[2]) + timedelta(days=5)
			facturacion_val = {
				'fecha_finalizacion':hora_fin, 
				'fecha_vencimiento':"%s %s" % (str(theDate), time.strftime("%H:%M:%S", temp)),
				}
			facturacion_obj = self.pool.get('oplog.facturacion')
			facturacion_ids = facturacion_obj.search(cr, uid, [('name', '=', dian_obj.name)])
			#print facturacion_ids
			if facturacion_ids and len(facturacion_ids) > 0:
				ret = facturacion_obj.write(cr, uid, facturacion_ids, facturacion_val)
		return ret and super(oplog_dian, self).write(cr, uid, ids, vals)
		
	def _getAciCode3(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			do_obj = self.browse(cr, uid, id).do_ids
			partner_obj = self.pool.get("res.partner")
			partner_id = partner_obj.search(cr, uid, [('name', '=', do_obj.aci)])
			if partner_id:
				print partner_obj.browse(cr, uid, partner_id[0])
				res[id] = partner_obj.browse(cr, uid, partner_id[0]).ref
		print res
		return res

	def _getDianAciCode(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			do_obj = self.browse(cr, uid, id).do_ids
			dian_codes = do_obj._getAciDianCode(cr, uid, [do_obj.id], name, args, context)
			if dian_codes:
				res[id] = dian_codes[do_obj.id]
		return res

	def _getACI(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			do_obj = self.browse(cr, uid, id).do_ids
			res[id] = do_obj.aci
		#print res
		return res
		
	def _getRegimen_Dian(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			do_obj = self.browse(cr, uid, id).do_ids
			res[id] = do_obj.regimen
		#print res
		return res

	def _getVessel(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			do_obj = self.browse(cr, uid, id).do_ids
			res[id] = do_obj.motonave
		#print res
		return res
		
	def _getViaje(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			do_obj = self.browse(cr, uid, id).do_ids
			res[id] = do_obj.viaje
		#print res
		return res

	def _getPort(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			do_obj = self.browse(cr, uid, id).do_ids
			res[id] = do_obj.puerto_llegada
		#print res
		return res

	def _getBLM(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			do_obj = self.browse(cr, uid, id).do_ids
			if do_obj.codigo_blmaster and do_obj.codigo_blmaster[0]:
				res[id] = do_obj.codigo_blmaster[0].name
		print res
		return res
	def _getBlhNumber(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			res[id] = 0
			do_obj = self.browse(cr, uid, id).do_ids
			retNums = do_obj._getBlhNumber(cr, uid, [do_obj.id], name, args)
			if retNums and retNums[do_obj.id]:
				res[id] = retNums[do_obj.id]
		#print res
		return res
	def _getContainerNumber(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			res[id] = 0
			do_obj = self.browse(cr, uid, id).do_ids
			retNums = do_obj._getContainerNumber(cr, uid, [do_obj.id], name, args)
			if retNums and retNums[do_obj.id]:
				res[id] = retNums[do_obj.id]
		#print res
		return res
	def _getContainerList(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			res[id] = 0
			do_obj = self.browse(cr, uid, id).do_ids
			blm_ids = []
			for blm in do_obj.codigo_blmaster:
				blm_ids.append(blm.id)
			if blm:
				conts = blm._getContainerList(cr, uid, blm_ids, name, args)
				res[id] = ",".join(conts.values())
		#print res
		return res
	def _getBlhList(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			res[id] = 0
			do_obj = self.browse(cr, uid, id).do_ids
			blm_ids = []
			for blm in do_obj.codigo_blmaster:
				blm_ids.append(blm.id)
			if blm:
				conts = blm._getBlhList(cr, uid, blm_ids, name, args)
				res[id] = ",".join(conts.values())
		#print res
		return res
	def _sel_func(self, cr, uid, context={}): 
		obj = self.pool.get('oplog.do') 
		ids = obj.search(cr, uid, [('state','=','tramite_dian')])
		res = obj.read(cr, uid, ids, ['name', 'id'], context) 
		res = [(r['id'], r['name']) for r in res] 
		return res
	def _getCreateUser(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			cr.execute('select u.name from oplog_dian d left join res_users u on COALESCE(d.write_uid, d.create_uid) = u.id where d.id=%d', (id,))
			uname = cr.fetchone()
			if uname and len(uname) > 0:
				res[id] = uname[0]
		#print res
		return res
	def _getUserSignature(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			cr.execute('select u.signature from oplog_dian d left join res_users u on COALESCE(d.write_uid, d.create_uid) = u.id where d.id=%d', (id,))
			uname = cr.fetchone()
			if uname and len(uname) > 0:
				res[id] = uname[0]
		#print res
		return res
	_name = 'oplog.dian'
	_log_access = True
	_columns = {
		# Dian process fields
		'name': fields.char('No. Manifiesto SYGA', size=20, help="Número del Aduanero DIAN"),
		'hora_syga': fields.datetime('Fecha Manifiesto SYGA'),
		'asocio_dian': fields.char('No. Paquete Consolidador', size=20),
		'hora_asocio': fields.datetime('Fecha Paquete Consolidador'),
		'electronico_dian': fields.char('Radicación electrónica / Asocio Dian', size=20),
		'hora_electronico': fields.datetime('Fecha Radicación electrónica'),
		#'fisico_dian': fields.boolean('Radicación Física DIAN'),
		'hora_dian': fields.datetime('Fecha Radicación DIAN'),
		#'fin_dian': fields.boolean('Finalizacion Descargue DIAN'),
		'hora_fin': fields.datetime('Fecha Finalización DIAN'),
		'tramitar':fields.char('Empleado', size=30),
		'observ_dian': fields.text('Observaciones'),
		# functional fields
		'aci_code3': fields.function(_getAciCode3, method=True, string='NIT', type='char', size=64),
		'aci_dian_code': fields.function(_getDianAciCode, method=True, string='Código DIAN', type='char', size=16),
		'aci_dian': fields.function(_getACI, method=True, string='ACI', readonly=True, type='char', size=45),
		'reg_dian': fields.function(_getRegimen_Dian, method=True, string='Modalidad', type='char', readonly=True),
		'port_dian': fields.function(_getPort, method=True, string='Puerto Arribo', type='char', size=32, readonly=True),
		'vessel_dian': fields.function(_getVessel, method=True, string='Motonave', type='char', size=20, readonly=True),
		'viaje_dian': fields.function(_getViaje, method=True, string='Viaje', type='char', size=20, readonly=True),
		'blm_dian': fields.function(_getBLM, method=True, string='B/L. Master', type='char', size=32, readonly=True),		
		'blh_counter': fields.function(_getBlhNumber, method=True, type='integer', string='No. BLH'),
		'cont_counter': fields.function(_getContainerNumber, method=True, type='integer', string='No. Contenedores'),
		# Relational fields
		'do_ids':fields.many2one('oplog.do','DO', size=64, select=True, required=True, selection=_sel_func),
		# User and record field
		#'user_id':fields.many2one('res.users','Responsable', size=20, readonly=True, select=True),
		'user_id': fields.function(_getCreateUser, method=True, type='char', string='Responsable'),
		'user_signature': fields.function(_getUserSignature, method=True, type='char', string='Firma'),
		'fecha_dian' : fields.datetime('Fecha DIAN', required=True, readonly=True),
		'cont_list': fields.function(_getContainerList, method=True, type='text', string='Containers List'),
		'blh_list': fields.function(_getBlhList, method=True, type='char', string='BLH List'),
				}

	_defaults = { 
		'fecha_dian': lambda *a: time.strftime('%Y-%m-%d %H:%M:%S'),
		#'state': lambda *a: 'inicio', (el que tenga el DO)
		#'user_id': lambda obj, cr, uid, context: uid,

				}
		
oplog_dian()

class oplog_radicado(osv.osv):
	def _getACI_Rad(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			do_obj = self.browse(cr, uid, id).do_rad_id
			res[id] = do_obj.aci
		#print res
		return res
	def _getAciCode(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			do_obj = self.browse(cr, uid, id).do_rad_id
			partner_obj = self.pool.get("res.partner")
			partner_id = partner_obj.search(cr, uid, [('name', '=', do_obj.aci)])
			if partner_id:
				#print partner_obj.browse(cr, uid, partner_id[0])
				res[id] = partner_obj.browse(cr, uid, partner_id[0]).ref
		#print res
		return res
	def _getBlhNumber(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			res[id] = 0
			do_obj = self.browse(cr, uid, id).do_rad_id
			retNums = do_obj._getBlhNumber(cr, uid, [do_obj.id], name, args)
			if retNums and retNums[do_obj.id]:
				res[id] = retNums[do_obj.id]
		#print res
		return res
	def _getBlmNumber(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			res[id] = 0
			do_obj = self.browse(cr, uid, id).do_rad_id
			retNums = do_obj._getBlmNumber(cr, uid, [do_obj.id], name, args)
			if retNums and retNums[do_obj.id]:
				res[id] = retNums[do_obj.id]
		#print res
		return res
	def _getBlmNameList(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			res[id] = 0
			do_obj = self.browse(cr, uid, id).do_rad_id
			blm_names = []
			for blm in do_obj.codigo_blmaster:
				blm_names.append(blm.name)
			res[id] = ",".join(blm_names)
		#print res
		return res
	def _getBlhConsigList(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			res[id] = 0
			do_obj = self.browse(cr, uid, id).do_rad_id
			consigs = []
			for blm in do_obj.codigo_blmaster:
				for blh in blm.codigo_blhijo:
					consigs.append(blh.consig_blh)
			res[id] = ",".join(consigs)
		#print res
		return res
	def _getContainerNumber(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			res[id] = 0
			do_obj = self.browse(cr, uid, id).do_rad_id
			#print do_obj
			retNums = do_obj._getContainerNumber(cr, uid, [do_obj.id], name, args)
			if retNums and retNums[do_obj.id]:
				res[id] = retNums[do_obj.id]
		#print res
		return res
	def _getContainerList(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			res[id] = 0
			do_obj = self.browse(cr, uid, id).do_rad_id
			blm_ids = []
			for blm in do_obj.codigo_blmaster:
				blm_ids.append(blm.id)
			if blm:
				conts = blm._getContainerList(cr, uid, blm_ids, name, args)
				res[id] = ",".join(conts.values())
		#print res
		return res
	def _getBlhList(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			res[id] = 0
			do_obj = self.browse(cr, uid, id).do_rad_id
			blm_ids = []
			for blm in do_obj.codigo_blmaster:
				blm_ids.append(blm.id)
			if blm:
				conts = blm._getBlhList(cr, uid, blm_ids, name, args)
				res[id] = ",".join(conts.values())
		#print res
		return res
	def _sel_func(self, cr, uid, context={}): 
		obj = self.pool.get('oplog.do') 
		ids = obj.search(cr, uid, [('state','=','tramite_dian'),('regimen','=','RADICACION')])
		res = obj.read(cr, uid, ids, ['name', 'id'], context) 
		res = [(r['id'], r['name']) for r in res] 
		return res
	def _getCreateUser(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			cr.execute('select u.name from oplog_radicado d left join res_users u on COALESCE(d.write_uid, d.create_uid) = u.id where d.id=%d', (id,))
			uname = cr.fetchone()
			if uname and len(uname) > 0:
				res[id] = uname[0]
		#print res
		return res
	def _getUserSignature(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			cr.execute('select u.signature from oplog_radicado d left join res_users u on COALESCE(d.write_uid, d.create_uid) = u.id where d.id=%d', (id,))
			uname = cr.fetchone()
			if uname and len(uname) > 0:
				res[id] = uname[0]
		#print res
		return res
	def _get_do_naviera(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			do_obj = self.browse(cr, uid, id).do_rad_id
			res[id] = do_obj.naviera
		return res
	_name = 'oplog.radicado'
	_log_access = True
	_columns = {
		'name': fields.char('Radicado', size=64),
		'aci_code4': fields.function(_getAciCode, method=True, string='NIT', type='char', size=64),
		'aci_rad': fields.function(_getACI_Rad, method=True, string='ACI', type='char', size=64),
		# 14. Solicitud de vistos buenos	Crear los Objetos para vistos buenos.
		#'vobo': fields.boolean('Vistos Buenos'),
		'fecha_vobo': fields.datetime('Fecha Vistos Buenos'),
		#15. Liberación de MBL	Crear campos de liberación MBL
		#'lib_mbl': fields.boolean('Liberación MBL'),
		'fecha_lib_mbl': fields.datetime('F.Lib. MBL'),
		#16. Solicitud paz y salvo	Crear campos datetime, boolean y valor integer
		#'pys': fields.boolean('Paz y Salvo'),
		'fecha_pys': fields.datetime('F. Paz y Salvo'),
		'valor_pys': fields.integer('Valor($) Paz y Salvo'),
		#17. Solicitud de factura de puerto	Boolean, fecha
		#'fact_pto': fields.boolean('Factura en puertos'),
		'fecha_fact_pto': fields.datetime('Fecha facturas'),
		'valor_fact_pto': fields.integer('Valor facturas'),
		#18. Solicitud de vaciado para desconsolidaión 	Boolean, fecha
		#'slc_vdo': fields.boolean('Solicitud vaciado'),
		#'fecha_slc_vdo': fields.datetime('Fecha solicitud vaciado'),
		#'parcial': fields.boolean('Vaciado parcial'),
		#'blh_vac_par': fields.many2many('oplog.blhijo','oplog_blh_vaciado_rel','child_id','parent_id','BLH(s) vac. par.'),
		#'operador': fields.char('Operador Portuario', size=32),
		#19. Vaciado contenedor •	Boolean •	Fecha •	Select: (Mercancías averiadas, Faltantes y sobrantes) •	Observaciones
		#'vac_cnt': fields.boolean('Vaciado contenedor'),
		#'date_vac_cnt': fields.datetime('Fecha vaciado'),
		#'inconsistencias': fields.selection([('Ninguna','Ninguna'),('Averias','Averias'),('Faltantes','Faltantes'),('Sobrantes','Sobrantes')],'Inconsistencias', size=32),
		#'observ_vac': fields.text('Observaciones durante el vaciado'),
		# 20. Solicitud de planilla entrega de mercancia al puerto	Boolean, fecha y observaciones
		'pln_cnt_no': fields.char('Planilla No.', size=32),
		#'pln_cnt': fields.boolean('Planilla entrega de Mercancias'),
		'date_pln_cnt': fields.datetime('Fecha planilla'),
		'observ_pln_cnt': fields.text('Observaciones entrega de Mercancia'),
		# 21. Finalización de operación en el SYGA. 	Se comprueba por el Workflow.
		# 22. Informe ACI	Zip- campo  binario.  Comprimir toda la evidencia, enviarla al ACI y almacenarla en el sistema.
		'ifm_pln': fields.boolean('Anexar Planillas'),
		'ifm_foto': fields.boolean('Anexar Fotos'),
		'ifm_aci': fields.boolean('Informe ACI'),
		'date_ifm_aci': fields.datetime('Fecha Inf. ACI'),
		#  
		'foto': fields.binary('Evidencia documental y fotográfica', help="Comprima en un archivo '.zip' los documentos y fotos resultantes de la operación de vaciado y anéxelos aqui."),
		# 23. Solicitud de planilla del contenedor	Boolean, fecha 	Datos críticos del contrato de comodato.  Tomar del contrato de muestra anexo.
		'comodato': fields.char('Comodato No.', size=32),
		'fecha_emision': fields.datetime('Emisión'),
		'inicio_moras': fields.datetime('Inicio Moras'),
		'fecha_vencimiento': fields.datetime('Vencimiento'),
		'operador_pln': fields.char('Operador', size=32),
		'operador_sia': fields.char('SIA', size=32),
		'contenedor_vacio': fields.datetime('Fecha Entrega Contenedor'),
		# 24. Entrega de planilla al transportador	Boolean, fecha y datos primordiales del comodato
		#'pln_trp': fields.boolean('Planilla transportador'),
		'date_pln_trp': fields.datetime('Fecha planilla'),
		'transportador': fields.char('Transportador', size=32),
		'observ_pln_trp': fields.text('Observaciones entrega de planilla'),		
		# 2%. Entrega de responsabilidades a la SIA Boolean, fecha y datos primordiales del comodato
		#'pln_sia': fields.boolean('Planilla transportador'),
		'date_pln_sia': fields.datetime('Fecha planilla'),
		'sia': fields.char('SIA', size=32),
		'observ_pln_sia': fields.text('Observaciones entrega de planilla'),		
		# Relational fields
		#'blh_vac_ids':fields.one2many('oplog.blhijo', 'name', 'B/L.H(s)', size=20, readonly=True, select=True),
		'do_rad_id': fields.many2one('oplog.do', 'DO#', size=32, required=True, selection=_sel_func),
		# User and record date fields
		#'user_id':fields.many2one('res.users','Realizó vaciado', size=20, readonly=True, select=True),
		'user_id': fields.function(_getCreateUser, method=True, type='char', string='Realizó radicado'),
		'fecha_radicado' : fields.datetime('Fecha Radicado', required=True, readonly=True),
		'blh_counter': fields.function(_getBlhNumber, method=True, type='integer', string='#BLH'),
		'cont_counter': fields.function(_getContainerNumber, method=True, type='integer', string='#Containers'),
		'blm_counter': fields.function(_getBlmNumber, method=True, type='char', string='#BLM'),
		'user_signature': fields.function(_getUserSignature, method=True, type='char', string='Signature'),
		'cont_list': fields.function(_getContainerList, method=True, type='text', string='Containers List'),
		'blh_list': fields.function(_getBlhList, method=True, type='char', string='BLH List'),
		'blm_name_list': fields.function(_getBlmNameList, method=True, type='char', string='BLM Name List'),
		'blh_consig_list': fields.function(_getBlhConsigList, method=True, type='char', string='BLH Consig List'),
				}

	_defaults = { 
		'fecha_radicado': lambda *a: time.strftime('%Y-%m-%d %H:%M:%S'),
		#'user_id': lambda obj, cr, uid, context: uid,
		#'inconsistencias': lambda *a: 'Ninguna',
				}



oplog_radicado()

class oplog_vaciado(osv.osv):

	def _getAciCode4(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			do_obj = self.browse(cr, uid, id).do_vac_id
			partner_obj = self.pool.get("res.partner")
			partner_id = partner_obj.search(cr, uid, [('name', '=', do_obj.aci)])
			if partner_id:
				print partner_obj.browse(cr, uid, partner_id[0])
				res[id] = partner_obj.browse(cr, uid, partner_id[0]).ref
		print res
		return res
	def _getBlhNumber(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			res[id] = 0
			do_obj = self.browse(cr, uid, id).do_vac_id
			retNums = do_obj._getBlhNumber(cr, uid, [do_obj.id], name, args)
			if retNums and retNums[do_obj.id]:
				res[id] = retNums[do_obj.id]
		#print res
		return res
	def _getContainerNumber(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			res[id] = 0
			do_obj = self.browse(cr, uid, id).do_vac_id
			retNums = do_obj._getContainerNumber(cr, uid, [do_obj.id], name, args)
			if retNums and retNums[do_obj.id]:
				res[id] = retNums[do_obj.id]
		#print res
		return res
	def _getContainerList(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			res[id] = 0
			do_obj = self.browse(cr, uid, id).do_vac_id
			blm_ids = []
			for blm in do_obj.codigo_blmaster:
				blm_ids.append(blm.id)
			if blm:
				conts = blm._getContainerList(cr, uid, blm_ids, name, args)
				res[id] = ",".join(conts.values())
		#print res
		return res
	def _sel_func(self, cr, uid, context={}): 
		obj = self.pool.get('oplog.do') 
		ids = obj.search(cr, uid, [('state','=','tramite_dian'),('regimen','=','VACIADO')])
		res = obj.read(cr, uid, ids, ['name', 'id'], context) 
		res = [(r['id'], r['name']) for r in res] 
		return res
	def _getCreateUser(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			cr.execute('select u.name from oplog_vaciado d left join res_users u on COALESCE(d.write_uid, d.create_uid) = u.id where d.id=%d', (id,))
			uname = cr.fetchone()
			if uname and len(uname) > 0:
				res[id] = uname[0]
		#print res
		return res
	def _getUserSignature(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			cr.execute('select u.signature from oplog_vaciado d left join res_users u on COALESCE(d.write_uid, d.create_uid) = u.id where d.id=%d', (id,))
			uname = cr.fetchone()
			if uname and len(uname) > 0:
				res[id] = uname[0]
		#print res
		return res
	_name = 'oplog.vaciado'
	_log_access = True
	_columns = {
		'name': fields.char('Vaciado', size=64),
		'aci_code4': fields.function(_getAciCode4, method=True, string='NIT', type='char', size=64),
		# 14. Solicitud de vistos buenos	Crear los Objetos para vistos buenos.
		#'vobo': fields.boolean('Vistos Buenos'),
		'fecha_vobo': fields.datetime('Fecha Vistos Buenos'),
		#15. Liberación de MBL	Crear campos de liberación MBL
		#'lib_mbl': fields.boolean('Liberación MBL'),
		'fecha_lib_mbl': fields.datetime('F.Lib. MBL'),
		#16. Solicitud paz y salvo	Crear campos datetime, boolean y valor integer
		#'pys': fields.boolean('Paz y Salvo'),
		'fecha_pys': fields.datetime('F. Paz y Salvo'),
		'valor_pys': fields.integer('Valor($) Paz y Salvo'),
		#17. Solicitud de factura de puerto	Boolean, fecha
		#'fact_pto': fields.boolean('Factura en puertos'),
		'fecha_fact_pto': fields.datetime('Fecha facturas'),
		'valor_fact_pto': fields.integer('Valor facturas'),
		#18. Solicitud de vaciado para desconsolidaión 	Boolean, fecha
		#'slc_vdo': fields.boolean('Solicitud vaciado'),
		'fecha_slc_vdo': fields.datetime('Fecha solicitud vaciado'),
		#'parcial': fields.boolean('Vaciado parcial'),
		'blh_vac_par': fields.many2many('oplog.blhijo','oplog_blh_vaciado_rel','child_id','parent_id','BLH(s) vac. par.'),
		'operador': fields.char('Operador Portuario', size=32),
		#19. Vaciado contenedor •	Boolean •	Fecha •	Select: (Mercancías averiadas, Faltantes y sobrantes) •	Observaciones
		#'vac_cnt': fields.boolean('Vaciado contenedor'),
		'date_vac_cnt': fields.datetime('Fecha vaciado'),
		'inconsistencias': fields.selection([('Ninguna','Ninguna'),('Averias','Averias'),('Faltantes','Faltantes'),('Sobrantes','Sobrantes')],'Inconsistencias', size=32),
		'observ_vac': fields.text('Observaciones durante el vaciado'),
		# 20. Solicitud de planilla entrega de mercancia al puerto	Boolean, fecha y observaciones
		'pln_cnt_no': fields.char('Planilla No.', size=32),
		# 'pln_cnt': fields.boolean('Planilla entrega de Mercancias'),
		'date_pln_cnt': fields.datetime('Fecha planilla'),
		'observ_pln_cnt': fields.text('Observaciones entrega de Mercancia'),
		# 21. Finalización de operación en el SYGA. 	Se comprueba por el Workflow.
		# 22. Informe ACI	Zip- campo  binario.  Comprimir toda la evidencia, enviarla al ACI y almacenarla en el sistema.
		'ifm_pln': fields.boolean('Anexar Planillas'),
		'ifm_foto': fields.boolean('Anexar Fotos'),
		# 'ifm_aci': fields.boolean('Informe ACI'),
		'date_ifm_aci': fields.datetime('Fecha Inf. ACI'),
		'foto': fields.binary('Evidencia documental y fotográfica', help="Comprima en un archivo '.zip' los documentos y fotos resultantes de la operación de vaciado y anéxelos aqui."),
		# 23. Solicitud de planilla del contenedor	Boolean, fecha 	Datos críticos del contrato de comodato.  Tomar del contrato de muestra anexo.
		'comodato': fields.char('Comodato No.', size=32, select=True),
		'fecha_emision': fields.datetime('Emisión'),
		'inicio_moras': fields.datetime('Inicio Moras'),
		'fecha_vencimiento': fields.datetime('Vencimiento'),
		'operador_pln': fields.char('Operador', size=32, select=True),
		'contenedor_vacio': fields.datetime('Fecha Entrega Contenedor Vacio'),
		'patio': fields.char('Patio', size=32, select=True),
		# 24. Entrega de planilla al transportador	Boolean, fecha y datos primordiales del comodato
		#'pln_trp': fields.boolean('Planilla transportador'),
		'date_pln_trp': fields.datetime('Fecha planilla'),
		'transportador': fields.char('Transportador', size=32),
		'observ_pln_trp': fields.text('Observaciones entrega de planilla'),		
		# Relational fields
		#'blh_vac_ids':fields.one2many('oplog.blhijo', 'name', 'B/L.H(s)', size=20, readonly=True, select=True),
		'do_vac_id': fields.many2one('oplog.do', 'DO#', size=32, required=True, select=True, selection=_sel_func),
		# User and record date fields
		#'user_id':fields.many2one('res.users','Realizó vaciado', size=20, readonly=True, select=True),
		'user_id': fields.function(_getCreateUser, method=True, type='char', string='Realizó vaciado'),
		'fecha_vaciado' : fields.datetime('Fecha Vaciado', required=True, readonly=True),
		'blh_counter': fields.function(_getBlhNumber, method=True, type='integer', string='#BLH'),
		'cont_counter': fields.function(_getContainerNumber, method=True, type='integer', string='#Containers'),
		'user_signature': fields.function(_getUserSignature, method=True, type='char', string='Signature'),
		'cont_list': fields.function(_getContainerList, method=True, type='text', string='Containers List'),
				}

	_defaults = { 
		'fecha_vaciado': lambda *a: time.strftime('%Y-%m-%d %H:%M:%S'),
		#'user_id': lambda obj, cr, uid, context: uid,
		'inconsistencias': lambda *a: 'Ninguna',
				}

oplog_vaciado()

class oplog_facturacion(osv.osv):
	def _after3Days(self, cr, uid, ids, name, args, context={}):
		return self.getDeltaDate2(cr, uid, ids, name, -3, context)
		
	def _after1Days(self, cr, uid, ids, name, args, context={}):
		return self.getDeltaDate2(cr, uid, ids, name, -1, context)
	def getDeltaDate2(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			facturacion = self.browse(cr, uid, id)
			if facturacion.fecha_vencimiento:
				temp = time.strptime(facturacion.fecha_vencimiento, '%Y-%m-%d %H:%M:%S')
				theDate = date(temp[0], temp[1], temp[2]) + timedelta(days=args)
				res[id] = str(theDate)
			else:
				res[id] = None
		#print res
		return res
	def _getRegimen_Fact(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			do_obj = self.browse(cr, uid, id).facturacion_id
			res[id] = do_obj.regimen
		#print res
		return res
	def _getACI_Fact(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			do_obj = self.browse(cr, uid, id).facturacion_id
			res[id] = do_obj.aci
		#print res
		return res

	def _sel_func(self, cr, uid, context={}): 
		obj = self.pool.get('oplog.do') 
		ids = obj.search(cr, uid, [('state','=','contabilidad')])
		res = obj.read(cr, uid, ids, ['name', 'id'], context) 
		res = [(r['id'], r['name']) for r in res] 
		return res
	def _getCreateUser(self, cr, uid, ids, name, args, context={}):
		res = {}
		for id in ids:
			cr.execute('select u.name from oplog_facturacion d left join res_users u on COALESCE(d.write_uid, d.create_uid) = u.id where d.id=%d', (id,))
			uname = cr.fetchone()
			if uname and len(uname) > 0:
				res[id] = uname[0]
		#print res
		return res
	_name = "oplog.facturacion"
	_log_access = True
	_columns = {
		'name': fields.char('No.Manifiesto SYGA', size=64),
		'fecha_finalizacion': fields.datetime('Fecha - Finalización SYGA', required=True),
		'fecha_vencimiento': fields.datetime('Fecha de vencimiento'),
		'fecha_vencimiento_3': fields.function(_after3Days, method=True, type='datetime', string='Fecha 3'),
		'fecha_vencimiento_1': fields.function(_after1Days, method=True, type='datetime', string='Fecha 1'),
		'aci_fact': fields.function(_getACI_Fact, method=True, string='ACI', type='char', readonly=True),
		'reg_fact': fields.function(_getRegimen_Fact, method=True, string='Regimen', type='char', readonly=True),
		'fact_do': fields.char('Factura No.', size=32),
		#'conf_fact': fields.boolean('Confirme facturación'),
		'fecha_facturacion': fields.datetime('Fecha facturación'),
		'observ_fac': fields.text('Observaciones'),
		# Relational Fields
		'facturacion_id': fields.many2one('oplog.do', 'DO#',size=32,required=True, select=True, selection=_sel_func),
		# User and record date fields
		#'user_id':fields.many2one('res.users','Realizó facturación', size=20, readonly=True, select=True),
		'user_id': fields.function(_getCreateUser, method=True, type='char', string='Realizó facturación'),
		'fecha_fact': fields.datetime('Fecha Facturación', required=True, readonly=True),
				}

	_defaults = {
		'fecha_fact': lambda *a: time.strftime('%Y-%m-%d %H:%M:%S'),
		#'user_id': lambda obj, cr, uid, context: uid,
				}

oplog_facturacion()

class oplog_aci_blh(osv.osv):
	def _aci2_get(self, cr, uid, context={}):
		obj = self.pool.get('res.partner')
		cr.execute('select category_id from res_partner_category_rel where category_id=3')
		category_ids = [x[0] for x in cr.fetchall()]
		ids = obj.search(cr, uid, [('active', '=', 'true'), ('category_id', 'in', category_ids)])
		res = obj.read(cr, uid, ids, ['name','active'], context)
		return [(r['name'], r['name']) for r in res]
	_name = "oplog.aci.blh"
	_description = "Reporte - Liberación de HBL(s)"
	_auto = False
	_columns = {
		'name': fields.char('Número B/L Hijo', size=64, readonly=True),
		'consig_blh': fields.char('Consignatario', size=128, readonly=True),
		'liberado' : fields.boolean('Liberado', readonly=True),
		'aci': fields.many2one('res.partner', 'ACI', readonly=True),
		'aci_name': fields.selection(_aci2_get,'ACI', readonly=True),
		'do_name': fields.char('DO#', size=64, readonly=True),
		'referencia': fields.char('Referencia', size=20, readonly=True),
		'motonave': fields.char('Motonave', size=20, readonly=True),
		'port': fields.char('Puerto', size=32, readonly=True),
		'consig_blm': fields.char('B/M Consignatario', size=64, readonly=True),
	}

	_order = 'aci_name, name'

# or c.liberado=False

	def init(self, cr):
		cr.execute("""
			create or replace view oplog_aci_blh as (
				select
					c.id,
					c.name,
					c.liberado,
					c.consig_blh,
					a.aci as aci_name,
					d.id as aci,
					a.name as do_name,
					a.referencia,
					a.motonave,
					a.puerto_llegada as port,
					b.consig_blm
				from oplog_do a
					left join oplog_blmaster b on (a.id=b.do_id)
					left join oplog_blhijo c on	(b.id=c.blmaster_id)
					left join res_partner d on (a.aci=d.name)
				where
					a.state in ('apertura','tramite_dian','contabilidad')
					and a.regimen <> 'COLOADING'
					and c.id is not null
			)
		""")
oplog_aci_blh()

class oplog_aci_do(osv.osv):
	def _aci2_get(self, cr, uid, context={}):
		obj = self.pool.get('res.partner')
		cr.execute('select category_id from res_partner_category_rel where category_id=3')
		category_ids = [x[0] for x in cr.fetchall()]
		ids = obj.search(cr, uid, [('active', '=', 'true'), ('category_id', 'in', category_ids)])
		res = obj.read(cr, uid, ids, ['name','active'], context)
		return [(r['name'], r['name']) for r in res]
	_name = "oplog.aci.do"
	_description = "Reporte - Solicitud de anticipos"
	_auto = False
	_columns = {
		'name': fields.char('Número DO#', size=64, readonly=True),
		'referencia': fields.char('Referencia', size=20, readonly=True),
		'concept': fields.char('Concepto', size=32, readonly=True),
		'container': fields.char('Contenedor',size = 14, readonly=True),
		'motonave': fields.char('Motonave', size=20, readonly=True),
		'port': fields.char('Puerto', size=32, readonly=True),
		'fecha_solicitud': fields.datetime('Fecha de solicitud', readonly=True),
		'total': fields.integer('Total de anticipos', digits=(12,0), readonly=True),
		'aci': fields.many2one('res.partner', 'ACI', readonly=True),
		'aci_name': fields.selection(_aci2_get,'ACI', readonly=True),
		'envio_fondos': fields.boolean('Recepción de fondos', readonly=True),
		'fecha_recibido': fields.datetime('Fecha Recepción', readonly=True),
		'blm_num': fields.char('Número B/L.-M', size=64, readonly=True),
		'cont_num': fields.integer('Container number of DO'),
		'blh_num': fields.integer('BLH number of DO'),
	}

	_order = 'aci_name, name'

# or b.envio_fondos=False
	
	# def init(self, cr):
		# cr.execute("""
			# create or replace view oplog_aci_do as (
				# select
					# a.id,
					# a.name,
					# a.referencia,
					# b.concept,
					# c.name as container,
					# a.motonave,
					# a.puerto_llegada as port,
					# b.fecha_solicitud,
					# (COALESCE(b.instalaciones,0)+COALESCE(b.almacenaje,0)+COALESCE(b.montacargas,0)+COALESCE(b.pesaje,0)+
					# COALESCE(b.traslado_vaciado,0)+COALESCE(b.traslaso_inspeccion,0)+COALESCE(b.deposito,0)+COALESCE(b.e_cargue,0)+
					# COALESCE(b.documental,0)+COALESCE(b.vaciado_cont,0)+COALESCE(b.acarreo,0)+COALESCE(b.cargue,0)+COALESCE(b.mbl_nav,0)+
					# COALESCE(b.hbl_sprc,0)+COALESCE(b.demora,0)+COALESCE(b.papeleria,0)+COALESCE(b.admon_cont,0)+COALESCE(b.dropoff,0)) as total,
					# d.id as aci,
					# a.aci as aci_name,
					# b.envio_fondos,
					# b.fecha_recibido,
					# c.blm_num
				# from oplog_do a
					# left join oplog_anticipo b on (a.id=b.fondos_id)
					# left join 
						# (SELECT cc.name as blm_num, cc.do_id, cc0.name from oplog_blmaster cc left join (
						# select blm_id, name from oplog_contenedor where id in (select min(id) as id from oplog_contenedor group by blm_id)) as cc0 
						# on cc.id=cc0.blm_id where cc.id in (select min(id) as id from oplog_blmaster group by do_id)) 
						# c on (a.id=c.do_id)
					# left join res_partner d on (a.aci=d.name)
				# where
					# a.state in ('apertura','tramite_dian','contabilidad') 
					# and a.regimen <> 'COLOADING'
					# and a.anticipos=True
					# and b.id is not null
			# )
		# """)
	def init(self, cr):
		cr.execute("""
			create or replace view oplog_aci_do as (
				select
					a.id,
					a.name,
					a.referencia,
					b.concept,
					c.name as container,
					a.motonave,
					a.puerto_llegada as port,
					b.fecha_solicitud,
					(COALESCE(b.instalaciones,0)+COALESCE(b.almacenaje,0)+COALESCE(b.montacargas,0)+COALESCE(b.pesaje,0)+
					COALESCE(b.traslado_vaciado,0)+COALESCE(b.traslaso_inspeccion,0)+COALESCE(b.deposito,0)+COALESCE(b.e_cargue,0)+
					COALESCE(b.documental,0)+COALESCE(b.vaciado_cont,0)+COALESCE(b.acarreo,0)+COALESCE(b.cargue,0)+COALESCE(b.mbl_nav,0)+
					COALESCE(b.hbl_sprc,0)+COALESCE(b.demora,0)+COALESCE(b.papeleria,0)+COALESCE(b.admon_cont,0)+COALESCE(b.dropoff,0)) as total,
					d.id as aci,
					a.aci as aci_name,
					b.envio_fondos,
					b.fecha_recibido,
					c.blm_num,
					c.cont_num,
					e.blh_num
				from oplog_do a
					left join oplog_anticipo b on (a.id=b.fondos_id)
					left join res_partner d on (a.aci=d.name)
					left join 
						(select cc.name as blm_num, cc.do_id, min(cc0.name) as name, sum(cc0.cont_num) as cont_num from oplog_blmaster cc left join (
						select 1 as cont_num, cc01.name, cc02.blmaster_id from oplog_contenedor cc01 inner join oplog_blhijo cc02 on cc01.blh_id = cc02.id) cc0
						on cc.id = cc0.blmaster_id where cc.id in (select min(id) as id from oplog_blmaster group by do_id) group by cc.name, cc.do_id )
						c on (a.id=c.do_id)
					left join 
						(select count('x') as blh_num, ee.do_id from oplog_blmaster ee
						inner join oplog_blhijo ee0 on ee.id = ee0.blmaster_id where ee.id in (select min(id) as id from oplog_blmaster group by do_id) group by ee.do_id, ee.id) e
						on (a.id=e.do_id)
				where
					a.state in ('apertura','tramite_dian','contabilidad') 
					and a.regimen <> 'COLOADING'
					and a.anticipos=True
					and b.id is not null
			)
		""")
oplog_aci_do()