﻿# -*- coding: utf-8 -*-

##############################################################################
#
# Copyright (c) 2007-2008 Naritas Ltda. (http://www.naritasltda.com) All Rights Reserved.
#
# $Id$
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License 
# Version 3 as published by the Free Software Foundation 
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

import wizard
import netsvc
import pooler

_blm_form = '''<?xml version="1.0"?>
<form string="Información del B/L Master">
	<separator string="Por favor copie la información del BLM desde aqui." colspan="4"/>
	<field name="name" colspan="4"/>
	<newline/>
	<!--<field name="contenido" colspan="4"/>-->
	<field name="dir_consig_blm"/>
	<field name="consdor_blm"/>
	<field name="dir_consdor_blm"/>
	<field name="cantidad"/>
	<!--<field name="clase_embalaje"/>-->
	<field name="peso"/>
	<field name="fh_ems_blm"/>
	<field name="do_blm"/>
	<field name="do_aci"/>
	<field name="do_ref"/>
	<field name="blh_name"/>
	<newline/>
	<field name="cont_list" colspan="4"/>
	<field name="blh_csg"/>
	<field name="fecha_blm"/>
	<newline/>
</form>'''

_blm_fields = {
	'name': {'string':'Número B/L.-M', 'type':'char', 'size':64},
	#'contenido': {'string':'Contenido', 'type':'char', 'size':255},
	'dir_consig_blm': {'string':'Dir. Consignatario', 'type':'char', 'size':200},
	'consdor_blm': {'string':'Consignador', 'type':'char', 'size':64},
	'dir_consdor_blm': {'string':'Consignador', 'type':'char', 'size':64},
	'cantidad': {'string':'Cantidad', 'type':'integer', 'size':64},
	# 'clase_embalaje': {'string':'Clase de embalaje', 'type':'char', 'size':30}, 
	'peso': {'string':'Peso (Kg.)', 'type':'float', 'size':20},
	'fh_ems_blm': {'string':'Fecha de corte', 'type':'char', 'size':20},
	'do_blm': {'string':'DO', 'type':'char', 'size':32},
	'do_aci': {'string':'ACI', 'type':'char', 'size':32},
	'do_ref': {'string':'Referencia', 'type':'char', 'size':32},
	'blh_name': {'string':'BLH', 'type':'char', 'size':32},
	'cont_list': {'string':'Contenedor', 'type':'text', 'size':500},
	'blh_csg': {'string':'Consignatario', 'type':'char', 'size':32},
	'fecha_blm': {'string':'Fecha BLM', 'type':'char', 'size':20},
}

_blh_form = '''<?xml version="1.0"?>
<form string="Informacion del BLH">
	<separator string="Por favor copie la información del BLH desde aqui." colspan="4"/>
	<field name="name" colspan="4"/>
	<field name="origen"/>
	<field name="pais_blh"/>
	<!-- <field name="clase_blh"/> -->
	<field name="peso_paquetes"/>
	<separator string="" colspan="4"/>
	<!-- <field name="contenido_bhl"/> -->
	<field name="cantidad"/>
	<field name="fh_ems_blh"/>
	<!-- <field name="descripcion_paquetes"/> -->
	<field name="consig_blh"/>
	<field name="dir_consig_blh"/>
	<field name="consid_blh"/>
	<field name="dir_consid_blh"/>
	<field name="aut_lib"/>
	<field name="fh_aut"/>
	<field name="liberado"/>
	<field name="fh_lib"/>
	<field name="nombre"/>
	<field name="cc"/>
	<field name="sia"/>
	<field name="contenedor_blh"/>
	<field name="fecha_blh"/>
	<newline/>
	<field name="contenedor" colspan="4"/>
</form>'''

_over_form = '''<?xml version="1.0"?>
<form string="Show finished.">
	<separator string="OK, los BLM/BLH han sido mostrados." colspan="4"/>
</form>'''

_over_fields = {}

_blh_fields = {
	'name': {'string':'Número B/L Hijo', 'type':'char','size':64},
	'origen': {'string':'Origen', 'type':'char','size':32},
	'pais_blh': {'string':'País', 'type':'char','size':64},
	# 'clase_blh': {'string':'Clase de embalaje', 'type':'char','size':32},
	'peso_paquetes': {'string':'Peso Paq.(Kg.)', 'type':'float','size':20},
	#'contenido_bhl': {'string':'Contenido', 'type':'char','size':255},
	'cantidad': {'string':'Cantidad', 'type':'float','size':20},
	'fh_ems_blh': {'string':'Fecha de corte', 'type':'char','size':20},
	# 'descripcion_paquetes': {'string':'Desc. de Paquetes', 'type':'char','size':30},
	'consig_blh': {'string':'Consignatario', 'type':'char','size':128},
	'dir_consig_blh': {'string':'Dir. Consignatario', 'type':'char','size':128},
	'consid_blh': {'string':'Consignador', 'type':'char','size':128},
	'dir_consid_blh': {'string':'Dir. Consignador', 'type':'char','size':128},
	'aut_lib' : {'string':'Autorizado para liberar', 'type':'char','size':64},
	'fh_aut': {'string':'Fecha y hora de la autorización', 'type':'char','size':20},
	'liberado' : {'string':'Liberado', 'type':'char','size':20},
	'fh_lib': {'string':'Fecha Liberación SIA', 'type':'char','size':20},
	'nombre': {'string':'Nombre', 'type':'char','size':32},
	'cc': {'string':'C.C.#', 'type':'char','size':32},
	'sia': {'string':'SIA', 'type':'char','size':32},
	'contenedor_blh': {'string':'Contenedor', 'type':'char','size':20},
	'fecha_blh': {'string':'Fecha BLH', 'type':'char','size':20},
	'contenedor': {'string':'Contenedor', 'type':'char','size':255},
}

_paquetes_form = '''<?xml version="1.0"?>
<form string="Informacion del Paquete">
	<separator string="Por favor copie la información del Paquete." colspan="4"/>
	<!-- <field name="name"/> -->
	<field name="cantidad"/>
	<field name="clase_paquetes"/>
	<field name="peso_paquetes"/>
	<newline/>
	<field name="descripcion_paquetes" colspan="4"/>
</form>'''

_paquetes_fields = {
	# 'name': {'string':'Paquete', 'type':'char','size':14},
	'cantidad': {'string':'Cantidad', 'type':'float'},
	'clase_paquetes': {'string':'Clase de embalaje', 'type':'char','size':32},
	'peso_paquetes': {'string':'Peso Paq.(Kg.)', 'type':'float'},
	'descripcion_paquetes': {'string':'Desc. de Paquetes', 'type':'text','size':1000},
}

_blm_list = []
_blh_list = []
_paquetes_list = []
_cur_blm_idx = 0
_cur_blh_idx = 0
_cur_paquetes_idx = 0
do_id = None

def _blm_first_get(self, cr, uid, data, context={}):
	service = netsvc.LocalService("object_proxy")
	global _blm_list, _cur_blm_idx, do_id
	res = filter(lambda x: x['do_ids'], service.execute(cr.dbname, uid, 'oplog.dian', 'read', data['ids']))
	if len(res) == 0:
		return {}
	do_id = res[0]['do_ids'][0]
	blm_obj = pooler.get_pool(cr.dbname).get('oplog.blmaster')
	_blm_list = blm_obj.search(cr, uid, [('do_id','=', do_id)])
	if len(_blm_list) == 0:
		return {}

	_cur_blm_idx = 0
	return blm_rec_get(cr, uid, data, context)

def blm_rec_get(cr, uid, data, context={}):
	global _blh_list, _cur_blh_idx
	service = netsvc.LocalService("object_proxy")
	res = service.execute(cr.dbname, uid, 'oplog.blmaster', 'read', [_blm_list[_cur_blm_idx]])
	if len(res) < 1:
		return {}

	# Fill blh ids list
	blh_obj = pooler.get_pool(cr.dbname).get('oplog.blhijo')
	_blh_list = blh_obj.search(cr, uid, [('blmaster_id','=', _blm_list[_cur_blm_idx])])
	_cur_blh_idx = 0

	# Fill return value
	# name = str(res[0]['name'])
	# contenido = str(res[0]['contenido'])
	# dir_consig_blm = str(res[0]['dir_consig_blm'])
	# consdor_blm = str(res[0]['consdor_blm'])
	# dir_consdor_blm = str(res[0]['dir_consdor_blm'])
	# fh_ems_blm = str(res[0]['fh_ems_blm'])
	# fecha_blm = str(res[0]['fecha_blm'])

	# return {'name': name, 'contenido': contenido, 'dir_consig_blm': dir_consig_blm, \
		# 'consdor_blm': consdor_blm, 'dir_consdor_blm': dir_consdor_blm, \
		# 'fh_ems_blm': fh_ems_blm, 'fecha_blm': fecha_blm, 'blm_idx':_cur_blm_idx, 'blms': str(_blm_list) }
	ret = {}
	for k in _blm_fields.keys():
		if type(res[0][k]) in [list, tuple]:
			ret[k] = str(res[0][k][-1])
		else:
			ret[k] = str(res[0][k])
	return ret

def _blm_again_get(self, cr, uid, data, context={}):
	global _cur_blm_idx
	
	# Get blm values
	_cur_blm_idx += 1
	if _cur_blm_idx >= len(_blm_list):
		_cur_blm_idx = 0
		return {}
	return blm_rec_get(cr, uid, data, context)

def _blh_rec_get(self, cr, uid, data, context={}):
	global _blm_list, _blh_list, _paquetes_list, _cur_blm_idx, _cur_blh_idx, _cur_paquetes_idx
	if len(_blh_list) == 0:
		return {}

	service = netsvc.LocalService("object_proxy")
	res = service.execute(cr.dbname, uid, 'oplog.blhijo', 'read', [_blh_list[_cur_blh_idx]])
	if len(res) < 1:
		return {}
		
	# Fill paquetes ids list
	paquetes_obj = pooler.get_pool(cr.dbname).get('oplog.paquetes')
	_paquetes_list = paquetes_obj.search(cr, uid, [('blh_id','=', _blh_list[_cur_blh_idx])])
	_cur_paquetes_idx = 0
	
	ret = {}
	for k in _blh_fields.keys():
		if k == 'contenedor':
			continue
		if type(res[0][k]) in [list, tuple]:
			ret[k] = str(res[0][k][-1])
		else:
			ret[k] = str(res[0][k])
	# Fill containers text
	#container_ids = res[0]['contenedor_id']
	cont_obj = pooler.get_pool(cr.dbname).get('oplog.contenedor')
	container_ids = cont_obj.search(cr, uid, [('blh_id','=', _blh_list[_cur_blh_idx])])
	cont_names = []
	#for cont_name in cont_obj.read(cr, uid, container_ids, ['name'], context):
	for cont_name in cont_obj.read(cr, uid, container_ids, ['name'], context):
		cont_names.append(cont_name['name'])
        
	ret['contenedor'] = ', '.join(cont_names)
	#ret['contenedor'] = str(cont_names)
	_cur_blh_idx += 1
	return ret
	
def _paquetes_rec_get(self, cr, uid, data, context={}):
	global _blh_list, _paquetes_list, _cur_blh_idx, _cur_paquetes_idx
	if len(_paquetes_list) == 0:
		return {}

	service = netsvc.LocalService("object_proxy")
	res = service.execute(cr.dbname, uid, 'oplog.paquetes', 'read', [_paquetes_list[_cur_paquetes_idx]])
	if len(res) < 1:
		return {}
	
	ret = {}
	for k in _paquetes_fields.keys():
		if type(res[0][k]) in [list, tuple]:
			ret[k] = str(res[0][k][-1])
		else:
			ret[k] = str(res[0][k])

	_cur_paquetes_idx += 1
	return ret

def _wo_check(self, cr, uid, data, context):
	if _cur_blm_idx+1 >= len(_blm_list) and _cur_blh_idx >= len(_blh_list) and _cur_paquetes_idx >= len(_paquetes_list):
		return 'over'
	elif _cur_blm_idx < len(_blm_list) and _cur_blh_idx >= len(_blh_list) and _cur_paquetes_idx >= len(_paquetes_list):
		return 'blm'
	elif _cur_blh_idx < len(_blh_list) and _cur_paquetes_idx >= len(_paquetes_list):
		return 'blh'
	else:
		return 'paquetes'

class copiar_pegar(wizard.interface):
	states = {
		'init' : {
			'actions' : [_blm_first_get],
			'result' : {'type' : 'form',
			'arch': _blm_form, 
			'fields': _blm_fields, 
			'state' : [('wo_check', 'Próximo'), ('end', 'Cancelar'), ]}
		},
		'wo_check': {
			'actions': [],
			'result' : {'type' : 'choice', 'next_state': _wo_check }
		},
		'blm' : {
			'actions' : [_blm_again_get],
			'result' : {'type' : 'form',
			'arch': _blm_form, 
			'fields': _blm_fields, 
			'state' : [('wo_check', 'Próximo')]}
		},
		'blh' : {
			'actions' : [_blh_rec_get],
			'result' : {'type' : 'form',
			'arch': _blh_form, 
			'fields': _blh_fields, 
			'state' : [('wo_check', 'Próximo')]}
		},
		'paquetes' : {
			'actions' : [_paquetes_rec_get],
			'result' : {'type' : 'form',
			'arch': _paquetes_form, 
			'fields': _paquetes_fields, 
			'state' : [('wo_check', 'Próximo')]}
		},
		'over' : {
			'actions' : [],
			'result' : {'type' : 'form',
			'arch': _over_form, 
			'fields': _over_fields, 
			'state' : [('end', 'OK')]}
		},
		'end' : {
			'actions' : [],
		}
	}

copiar_pegar("oplog.dian.copiar_pegar")